/*
*  This file is part of Emma Virtual Machine
*  Copyright (C) 2003 Vitja Makarov <no1sm@narod.ru>
*  
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "cpu.h"

int CPU::int_12h(){
CPU_AX=640;
return 1;
}

int CPU::int_10h(){
    switch(CPU_AH)
    {
    case 0xe:
    putchar(CPU_AL);//!!!
    fflush(stdout);
//    printf("!!:%c\n",CPU_AL);
//    WARN_MSG("int 10");
    fprintf(LOG,"INT10h: char is `%c\'",CPU_AL);
    break;
    }
return 1;
}
int CPU::int_19h()
{
//IP=0x7c00;
//CPU_CS=0;
printf("This interrupt inn''t released!!yes\n");
getchar();
return 1;
}
/*
struct EqList{
_byte diskdrv:1;
_byte nm:1
_byte mmoard:2;
_byte vmode:2;
_byte diskn:2;
_byte dma:1;
_byte
};
*/
//EquipmentList
int CPU::int_11h(){
_word eqlist;

//#define EQ_DISKDRV 0x1 //disk driver present
//#define EQ_COPROC  0x2 //coprocessor present
eqlist=1+1<<6;

//store list
CPU_AX=eqlist;
return 1;
}

// BIOS disk I/O
int CPU::int_13h(){
short drive, head, sect, track, number;
int err;
char *dest;

    switch(CPU_AH)
    {
    //reset controller
    case 0:
    
    CPU_AH=0;//now we can't handle errors
    FLAGS.CF=0;
    break;
    // get status
    case 1:
    // it's realy undone
      if(CPU_DL<fdN)
        CPU_AH=0;
      else
       CPU_AH=0x0c;
	
    break;
    // read sectors
    case 2:
    dest=SEG_ADR((char *),CPU_ES,CPU_BX);
    drive = CPU_DL;
    number= CPU_AL;
    track = CPU_CH;
    head  = CPU_DH;
    sect  = CPU_CL-1;
//    track = (CPU_CH) |
//      ((CPU_CX & 0xc0) << 2);
    sect=(CPU_CL & 0x3f) - 1;
    // store error code in AH as it needed, readSector() should return
    // true bios errorcode 
    err=readSector(drive,dest,head,sect,track,number);    
	if(err<0){
	  CPU_AH=-err;
	  FLAGS.CF=1;
	  }else	  {
	  FLAGS.CF=0;
	  }
	 
    break;
    default: 
    fprintf(stderr,"Unhandled interrupt 13: AH=0x%x\n",CPU_AH);
    FLAGS.CF=0;
    }
return 1;
}
//
int CPU::inter(int n){
    switch(n)
    {
    case 0x13:
    return int_13h();
    case 0x11:
    return int_11h();
    case 0x12:
    return int_12h();
    case 0x10:
    return int_10h();
    case 0x19:
    return int_19h();
    default:
    fprintf(stderr,"Unhandled interrupt 0x%x: AH=%x\n",n,CPU_AH);
    }
return 0;    
};
