// created by ../foo
// author: Vitja Makarov (c) 2003;
// see ../../COPYING for details

#include "cpu.h"

int CPU::CPU_adcS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif
res=OP_1+OP_2+get_bit(__eflags,CF);
set_flags_adc(OP_1,OP_2,res,OP_S1);
OP_1=res;
}

int CPU::CPU_adcb(){
Bit8u res;
res=OP_1+OP_2+get_bit(__eflags,CF);
set_flags_adc(OP_1,OP_2,res,OP_S1);
OP_1=res;
}

int CPU::CPU_addS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif
res=OP_1+OP_2;
set_flags_add(OP_1,OP_2,res,OP_S1);
OP_1=res;
}

int CPU::CPU_addb(){
Bit8u res;
res=OP_1+OP_2;
set_flags_add(OP_1,OP_2,res,OP_S1);
OP_1=res;
}

int CPU::CPU_andS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif
res=OP_1&OP_2;
set_flags_logical(OP_1,OP_2,res,OP_S1);
OP_1=res;
}

int CPU::CPU_andb(){
Bit8u res;
res=OP_1&OP_2;
set_flags_logical(OP_1,OP_2,res,1);
OP_1=res;
}

int CPU::CPU_a32(){
    STH_THIS amode=1;
    i_gonext();
    STH_THIS amode=0;
}

int CPU::CPU_aaa(){
    register Bit8u alc; /* AL carry */
    
    alc = _AL > 0xf9;
    
	if(((_AL&0x0f) > 0x9) || get_bit(__eflags,AF) )
	{
	    _AL = (_AL + 6) & 0x0f;
	    _AH += 1+ alc;
	    set_bit(__eflags,CF|AF);
	}else{
	clear_bit(__eflags,AF|CF);
	_AL&=0x0f;
	}
}

int CPU::CPU_aad(){
_AL=(_AH*(Bit8u)OP_1+_AL)&0xff;
_AH=0;//?
}

int CPU::CPU_aam(){
Bit8u al;
al=_AL;
    if(OP_1==0)
        return;
_AH=al/OP_1;
_AL=al%OP_1;

}

int CPU::CPU_aas(){
Bit16u al=_AL;
 if((al&0xf)>0x9 || get_bit(__eflags,AF)){
    al=(al-6)&0xf;
    _AH=_AH-1-(_AL<6);
    stc();sta();
 }else{
    clear_bit(__eflags,CF|AF);
//    FLAGS.CF=FLAGS.AF=0;
    clc();cla();
    al&=0xf;
 }
_AL=al;
}

int CPU::CPU_arpl(){
	exception(EXC_UD);
}
