// created by ../foo
// author: Vitja Makarov (c) 2003;
// see ../../COPYING for details

#include "cpu.h"
#include "dis386.h"

int CPU::CPU_cmpS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif
res=OP_1-OP_2;
set_flags_sub(OP_1,OP_2,res,OP_S1);
}

int CPU::CPU_cmpb(){
Bit8u res;
res=OP_1-OP_2;
set_flags_sub(OP_1,OP_2,res,OP_S1);
}

//! C
int CPU::CPU_cmpsS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif

    res=OP_1-OP_2;
    set_flags_sub(OP_1,OP_2,res,OP_S1);
}

//! C
int CPU::CPU_cmpsb(){
Bit8u res;
    res=OP_1-OP_2;
    set_flags_sub(OP_1,OP_2,res,OP_S1);
}


int CPU::CPU_cStd(){
# if OSIZE
    Bit64u r;
    r=_EAX;
    r=(Bit64s)(_EAX_S);
    _EAX=r&0xffffffff;
    _EDX=r>>32;
# else
    Bit32u r;
    r=(Bit32s)(_AX_S);
    _AX=r&0xffff;
    _DX=r>>16;
# endif
}

int CPU::CPU_cWtS(){
# if OSIZE
    _EAX=(Bit32s)(_AX_S);
# else
    _AX=(Bit16s)(_AL_S);
# endif
}

//near call relativetive and absolute
int CPU::CPU_call(){
sync_eip();
  if(STH_THIS amode)
     stack_push32(eip);
  else
     stack_push16(eip);
#ifdef __call_rel__
  sync_eip();
  eip+=OP_1;
#else /* absolute */
  eip=OP_1;
#endif
  sync_code_ptr();

}

int CPU::CPU_clc(){
    clc();
}

int CPU::CPU_cld(){
    cld();
}

int CPU::CPU_cli(){
    cli();
}

int CPU::CPU_clts(){
	exception(EXC_UD);
}

int CPU::CPU_cmc(){
    __eflags^=CF;
}

int CPU::CPU_cmova(){
	exception(EXC_UD);
}

int CPU::CPU_cmovae(){
	exception(EXC_UD);
}

int CPU::CPU_cmovb(){
	exception(EXC_UD);
}

int CPU::CPU_cmovbe(){
	exception(EXC_UD);
}

int CPU::CPU_cmove(){
	exception(EXC_UD);
}

int CPU::CPU_cmovg(){
	exception(EXC_UD);
}

int CPU::CPU_cmovge(){
	exception(EXC_UD);
}

int CPU::CPU_cmovl(){
	exception(EXC_UD);
}

int CPU::CPU_cmovle(){
	exception(EXC_UD);
}

int CPU::CPU_cmovne(){
	exception(EXC_UD);
}

int CPU::CPU_cmovno(){
	exception(EXC_UD);
}

int CPU::CPU_cmovnp(){
	exception(EXC_UD);
}

int CPU::CPU_cmovns(){
	exception(EXC_UD);
}

int CPU::CPU_cmovo(){
	exception(EXC_UD);
}

int CPU::CPU_cmovp(){
	exception(EXC_UD);
}

int CPU::CPU_cmovs(){
	exception(EXC_UD);
}

int CPU::CPU_cmpxchg8b(){
	exception(EXC_UD);
}

int CPU::CPU_cmpxchgS(){
	exception(EXC_UD);
}

int CPU::CPU_cmpxchgb(){
	exception(EXC_UD);
}

int CPU::CPU_cpuid(){
const Bit32u EMMA_MAGIC=0x456d6d61; // "Emma"
    switch(_EAX)
    {
    case 0:
    _EAX=1;
    _EBX=EMMA_MAGIC;
    _EDX=0;
    _ECX=0;
    break;
    }
}

int CPU::CPU_cs(){
    STH_THIS segment=_cs_;
    i_gonext();
    STH_THIS segment=_zero_;
}
