// created by ../foo
// author: Vitja Makarov (c) 2003;
// see ../../COPYING for details

#include "cpu.h"

//! 1:s 2:s
int CPU::CPU_idivS(){
# if OSIZE
    Bit64s src;
    src = ( ( (Bit64u) _EDX) <<32) + _EAX;
    _EAX = src/OP_2;
    _EDX = src%OP_2;
# else
    Bit32s src;
    src=(_DX<<16)+_AX;
    _AX=src/OP_2;
    _DX=src%OP_2;
# endif
}

//! 1:s 2:s
int CPU::CPU_idivb(){
Bit16u ax;
ax=_AX;
_AL=Bit16s((Bit16s)ax/(Bit8s)OP_2);
_AH=Bit16s((Bit16s)ax%(Bit8s)OP_2);
}

int CPU::CPU_incS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif
res=OP_1+1;
set_flags_inc(OP_1,1,res,OP_S1);
OP_1=res;
}

int CPU::CPU_incb(){
Bit8u res;
res=OP_1+1;
set_flags_inc(OP_1,1,res,OP_S1);
OP_1=res;
}

//! 1:s 2:s
int CPU::CPU_imulSA(){
# if OSIZE
    Bit64s res;
    res=((Bit32s)_EAX)*OP_1;
    _EAX=res&0xffffffff;
    _EDX=res>>32;
	if(res==0||res==0xffffffff)
	 {
	 clc();clo();
	 }else{
	 stc();sto();
	 }
# else
    Bit32s res;
    res=((Bit16s)_AX)*OP_1;
    _AX=res&0xffff;
    _DX=res>>16;
	if(res==0||res==0xffff)
	 {
	 clc();clo();
	 }else{
	 stc();sto();
	 }
# endif    
}

int CPU::CPU_imulSB(){
	exception(EXC_UD);
}

//! 1:s 2:s 3:s
int CPU::CPU_imulSC(){
# if OSIZE
    Bit64s res;
    res=OP_2*OP_3;
    OP_1=res;
# else
    Bit32s res;
    res=OP_2*OP_3;
    OP_1=res;
#endif
	if(res!=OP_1){
	 clc();clo();
	 }else{
	 stc();sto();
	 }
}

int CPU::CPU_imulbA(){
    _AX=(signed char)(_AL)*(signed char)(OP_1);
    if(_AH==0){
      clo();clc();
      }
    else{
      sto();stc();    
      }
}

int CPU::CPU_inS(){
# if OSIZE
    OP_1=STH_THIS e_in32(OP_2);
# else    
    OP_1=STH_THIS e_in16(OP_2);
# endif    
}

int CPU::CPU_inb(){
    OP_1=STH_THIS  e_in8(OP_2);
}

//! R
int CPU::CPU_insS(){
# if OSIZE
    OP_1=STH_THIS e_in32(OP_2);
# else    
    OP_1=STH_THIS e_in16(OP_2);
# endif    
}

//! R
int CPU::CPU_insb(){
    OP_1=STH_THIS  e_in8(OP_2);
}

int CPU::CPU_int(){
char *int_ptr;

stack_push16(__eflags);
clear_bit(__eflags,IF|TF|AC);
sync_eip();
stack_push16(_CS);
stack_push16(eip);
int_ptr = (char *)memptr(0,4*OP_1);
eip = *(Bit16u *)int_ptr;
int_ptr+=2;
_CS = *(Bit16u *)int_ptr;
//*(++(Bit16u *)int_ptr);
sync_code();
}

int CPU::CPU_int3(){
	exception(EXC_UD);
}

int CPU::CPU_into(){
	exception(EXC_UD);
}

int CPU::CPU_invd(){
	exception(EXC_UD);
}

int CPU::CPU_invlpg(){
	exception(EXC_UD);
}

int CPU::CPU_iret(){
    eip=stack_pop16();
    _CS=stack_pop16();
    LOWORD(__eflags)=stack_pop16();
    sync_code();
}
