// created by ../foo
// author: Vitja Makarov (c) 2003;
// see ../../COPYING for details

#include "cpu.h"
#include "dis386.h"

// near jump
int CPU::CPU_jmp(){
# ifdef __jmp_rel__
	sync_eip();
        eip+=OP_1;
# else
        eip=OP_1;
# endif
  sync_code_ptr();
}

int CPU::CPU_jcxz(){
# if OSIZE==1
  if(!_ECX)
# else
  if(!_CX)
# endif
  // jcxz and all conditional always use rel
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}

// carry
int CPU::CPU_jc(){
  if(get_bit(__eflags,CF))
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}
int CPU::CPU_jnc(){
      if(!get_bit(__eflags,CF))
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}
// zero
int CPU::CPU_jz(){
      if(get_bit(__eflags,ZF))
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}
int CPU::CPU_jnz(){
  if(!get_bit(__eflags,ZF))
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}
// overflow
int CPU::CPU_jo(){
  if(get_bit(__eflags,OF))
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}
int CPU::CPU_jno(){
      if(!get_bit(__eflags,OF))
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}
//parity
int CPU::CPU_jp(){
      if(get_bit(__eflags,PF))
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}
int CPU::CPU_jnp(){
      if(!get_bit(__eflags,PF))
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}
//sign
int CPU::CPU_js(){
      if(get_bit(__eflags,SF))
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}
int CPU::CPU_jns(){
      if(!get_bit(__eflags,SF))
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}

// [NOT] below or equal
int CPU::CPU_jbe(){
      if(get_bit(__eflags,CF) || get_bit(__eflags,ZF))
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}
int CPU::CPU_jnbe(){
      if(!get_bit(__eflags,CF) && !get_bit(__eflags,ZF))
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}

// [NOT] less
int CPU::CPU_jl(){
    if(get_bit(__eflags,SF) != get_bit(__eflags,OF))
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}
int CPU::CPU_jnl(){
    if(get_bit(__eflags,SF) == get_bit(__eflags,OF))
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}
// [NOT] less or equal
int CPU::CPU_jle(){
    if(get_bit(__eflags,ZF) || (get_bit(__eflags,SF) != get_bit(__eflags,OF)))
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}
int CPU::CPU_jnle(){
    if(!get_bit(__eflags,ZF) && (get_bit(__eflags,SF) == get_bit(__eflags,OF)))
	{
	sync_eip();
        eip+=OP_1;
	sync_code_ptr();
	}
}
