// created by ../foo
// author: Vitja Makarov (c) 2003;
// see ../../COPYING for details
#include "cpu.h"
#include "dis386.h"


int CPU::CPU_lahf(){
_AH=get_bit(__eflags,CF)+
(   get_bit(__eflags,PF)<<2)+
(   get_bit(__eflags,AF)<<4)+
(   get_bit(__eflags,ZF)<<6)+
(   get_bit(__eflags,SF)<<7);
}

int CPU::CPU_larS(){
	exception(EXC_UD);
}

int CPU::CPU_lcall(){
# ifdef __lcall_rm__
 if (RM_ISREG())
   exception(EXC_UD);
# endif
 stack_push16(_CS); 
 sync_eip();
# if OSIZE==1
   stack_push32(eip);
# else
   stack_push16(eip);
# endif


 eip=OP_1;
  op_1_p++;
 _CS=*(Bit16u *)op_1_p;
 sync_code();
}


int CPU::CPU_ldsS(){
      if(RM_ISREG())
  	 exception(EXC_UD);
  OP_1=*(op_2_p++);
  _DS=*(Bit16u *)op_2_p;
}

int CPU::CPU_leaS(){
 if(RM_ISREG())
   exception(EXC_UD);
 OP_1=countOFF();
}

int CPU::CPU_leave(){
//    if(stackAddr==16)
	{
	    _SP=_BP;
	}/*else{//we got bitD in descriptor
	    _ESP=_EBP;
	}*/
# if OSIZE
    _EBP=stack_pop32();
# else
    _BP=stack_pop16();
# endif
}

int CPU::CPU_lesS(){
      if(RM_ISREG())
  	 exception(EXC_UD);
  OP_1=*(op_2_p++);
  _ES=*(Bit16u *)op_2_p;
}

int CPU::CPU_lfsS(){
      if(RM_ISREG())
  	 exception(EXC_UD);
  OP_1=*(op_2_p++);
  _FS=*(Bit16u *)op_2_p;
}

int CPU::CPU_lgdt(){
	exception(EXC_UD);
}

int CPU::CPU_lgsS(){
      if(RM_ISREG())
  	 exception(EXC_UD);
  OP_1=*(op_2_p++);
  _GS=*(Bit16u *)op_2_p;
}


int CPU::CPU_lidt(){
	exception(EXC_UD);
}

int CPU::CPU_ljmp(){
# ifdef __ljmp_rm__
 if (RM_ISREG())
   exception(EXC_UD);
# endif

 eip=OP_1;
  op_1_p++;
 _CS=*(Bit16u *)op_1_p;
 sync_code();
}

int CPU::CPU_lldt(){
	exception(EXC_UD);
}

int CPU::CPU_lmsw(){
	exception(EXC_UD);
}

int CPU::CPU_lock(){
 STH_THIS pref_lock=1;
 i_gonext();
 STH_THIS pref_lock=0;
}

//! R
int CPU::CPU_lodsS(){
OP_1=OP_2;
}

//! R
int CPU::CPU_lodsb(){
OP_1=OP_2;
}

int CPU::CPU_loop(){
# if OSIZE==1
  if(--_ECX)
#else
  if(--_CX)
#endif
    {
    sync_eip();
    eip+=OP_1;
    sync_code();
    }
}

int CPU::CPU_loope(){
# if OSIZE==1
  if(--_ECX && get_bit(__eflags,ZF))
#else
  if(--_CX && get_bit(__eflags,ZF))
#endif
    {
    sync_eip();
    eip+=OP_1;
    sync_code();
    }
}

int CPU::CPU_loopne(){
# if OSIZE==1
  if(--_ECX && !get_bit(__eflags,ZF))
#else
  if(--_CX && !get_bit(__eflags,ZF))
#endif
    {
    sync_eip();
    eip+=OP_1;
    sync_code();
    }
}

// far or long RET
int CPU::CPU_lret(){
eip=stack_pop16();
_CS=stack_pop16();

# ifdef __lret_imm__
    if(STH_THIS amode)
	_ESP+=OP_1;
    else
	_SP+=OP_1;
# endif
    sync_code();
}

int CPU::CPU_lslS(){
	exception(EXC_UD);
}

int CPU::CPU_lssS(){
      if(RM_ISREG())
  	 exception(EXC_UD);
  OP_1=*(op_2_p++);
  _SS=*(Bit16u *)op_2_p;
}

int CPU::CPU_ltr(){
	exception(EXC_UD);
}
