// created by ../foo
// author: Vitja Makarov (c) 2003;
// see ../../COPYING for details

#include "cpu.h"

int CPU::CPU_repne(){
    STH_THIS pref_rep=2;
    i_gonext();    
    STH_THIS pref_rep=0;
}

int CPU::CPU_repz(){
    STH_THIS pref_rep=1;
    i_gonext();    
    STH_THIS pref_rep=0;
}

int CPU::CPU_rclS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif
Bit8u count;
count=OP_2%(OP_S1*8+1);
    if(count==0)
     return;
res=OP_1<<count;
res|=get_bit(__eflags,CF)<<(count-1);
res|=OP_1>>(OP_S1*8-count+1);
set_flags_rcl(OP_1,count,res,OP_S1);
OP_1=res;
}

int CPU::CPU_rclb(){
Bit8u res;
Bit8u count;
count=OP_2%(9);
    if(count==0)
     return;
res=OP_1<<count;
res|=get_bit(__eflags,CF)<<(count-1);
res|=OP_1>>(9-count);
set_flags_rcl(OP_1,count,res,1);
OP_1=res;
}

int CPU::CPU_rcrS(){
unsigned count;
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif
    count=OP_2%(OP_S1*8+1);
    if(!count)
	return; 
res=(OP_1>>count)|(get_bit(__eflags,CF)<<(OP_S1*8-count))| 
				(OP_1<<(OP_S1*8+1-count));
sc_bit(__eflags,CF, (OP_1>>(count-1))&1);
    if(count==1)
       sc_bit(__eflags,OF,((OP_1^res)&sign_bit(OP_S1))&&0x1);
OP_1=res;	
}

int CPU::CPU_rcrb(){
unsigned count;
Bit8u res;
    count=OP_2%9;
    if(!count)
	return;
res=(OP_1>>count)|(get_bit(__eflags,CF)<<(8-count))| 
				(OP_1<<(9-count));
sc_bit(__eflags,CF, (OP_1>>(count-1))&1);
    if(count==1)
       sc_bit(__eflags,OF,((OP_1^res)&0x80)&&0x1);
OP_1=res;	
}

int CPU::CPU_rolS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif
unsigned char count;
count=(OP_2&0x1f)%(OP_S1*8);
    if(count==0)
	return;
res=(OP_1 << count) + (OP_1 >> (OP_S1*8 - count));
set_flags_ror(OP_1,count,res,OP_S1);
OP_1=res;
}

int CPU::CPU_rolb(){
Bit8u res;
unsigned char count;
count=(OP_2&0x1f)%8;
    if(count==0)
	return;
res=(OP_1 << count) + (OP_1 >> (8 - count));
set_flags_ror(OP_1,count,res,1);
OP_1=res;
}

int CPU::CPU_rorS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif
unsigned char count;
count=(OP_2&0x1f)%(OP_S1*8);
    if(count==0)
	return;
res=(OP_1 >> count) + (OP_1 << (OP_S1*8 - count));
set_flags_ror(OP_1,count,res,OP_S1);
OP_1=res;
}

int CPU::CPU_rorb(){
Bit8u res;
unsigned char count;
count=(OP_2&0x1f)%8;
    if(count==0)
	return;
res=(OP_1 >> count) + (OP_1 << (8 - count));
set_flags_ror(OP_1,count,res,1);
OP_1=res;
}

int CPU::CPU_rdmsr(){
	exception(EXC_UD);
}

int CPU::CPU_rdpmc(){
	exception(EXC_UD);
}

int CPU::CPU_rdtsc(){
	exception(EXC_UD);
}
//near ret
int CPU::CPU_ret(){
eip=stack_pop16();
# ifdef __ret_imm__
  if(STH_THIS amode)
    _ESP+=OP_1;
    else
    _SP+=OP_1;
# endif
sync_code_ptr();
}

int CPU::CPU_rsm(){
	exception(EXC_UD);
}
