// created by ../foo
// author: Vitja Makarov (c) 2003;
// see ../../COPYING for details

#include "cpu.h"


int CPU::CPU_sahf(){
sc_bit(__eflags,CF,_AH&0x1 ?1:0);
sc_bit(__eflags,PF,_AH&0x4 ?1:0);
sc_bit(__eflags,AF,_AH&0x10?1:0);
sc_bit(__eflags,ZF,_AH&0x40?1:0);
sc_bit(__eflags,SF,_AH&0x80?1:0);
}

int CPU::CPU_sarS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif
short count;
count=OP_2&0x1f;
    if(!count)
     return;
res=OP_1>>count;
    if(OP_1 & sign_bit(OP_S1)){
	res|=val_mask(OP_S1)<<(OP_S1*8-count);
    }
set_flags_shr(OP_1,count,res,OP_S1);
OP_1=res;     
}

int CPU::CPU_sarb(){
short count;
Bit8u res;
count=OP_2&0x1f;
    if(!count)
     return;
res=OP_1>>count;
    if(OP_1&0x80){
	res|=0xff<<(8-count);
    }
set_flags_shr(OP_1,count,res,1);
OP_1=res;     
}

int CPU::CPU_sbbS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif

res=OP_1-(OP_2+get_bit(__eflags,CF));
set_flags_sbb(OP_1,OP_2,res,OP_S1);
OP_1=res;
}

int CPU::CPU_sbbb(){
Bit8u res;
res=OP_1-(OP_2+get_bit(__eflags,CF));
set_flags_sbb(OP_1,OP_2,res,1);
OP_1=res;
}

//! C
int CPU::CPU_scasS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif

res=OP_1-OP_2;
set_flags_sub(OP_1,OP_2,res,OP_S1);
}


//! C
int CPU::CPU_scasb(){
Bit8u res;
    res=OP_1-OP_2;
    set_flags_sub(OP_1,OP_2,res,1);
}

int CPU::CPU_shlS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif
res=OP_1<<(OP_2&0x1f);
set_flags_shl(OP_1,OP_2,res,OP_S1);
OP_1=res;
//return 1;
}

int CPU::CPU_shlb(){
Bit8u res;
res=OP_1<<(OP_2&0x1f);
set_flags_shl(OP_1,OP_2,res,1);
OP_1=res;
//return 1;
}

int CPU::CPU_shldS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif
int count;
int oldsf=get_bit(__eflags,SF);
count=OP_3%32; // MOD 32
    if(!count)
     return;
res=(OP_1<<count)|(OP_2>>(OP_S1*8-count));
set_szp(res,OP_S1);
    if(count==1)
	sc_bit(__eflags,OF,oldsf!=get_bit(__eflags,SF));
sc_bit(__eflags,CF,(res>>(count-1))&0x1);
OP_1=res;
//return 1;
}

int CPU::CPU_shrS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif
short op2;
op2=OP_2&0x1f;
res=OP_1>>(op2);
set_flags_shr(OP_1,op2,res,OP_S1);
OP_1=res;
//return 1;
}

int CPU::CPU_shrb(){
Bit8u  res;
short  op2;
op2=OP_2&0x1f;
res=OP_1>>(op2);
set_flags_shr(OP_1,op2,res,1);
OP_1=res;
//return 1;
}


int CPU::CPU_shrdS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif
int count;
int oldsf=get_bit(__eflags,SF);
count=OP_3%32; // MOD 32
    if(!count)
     return;
res=(OP_1>>count)|(OP_2<<(OP_S1*8-count));
set_szp(res,OP_S1);
    if(count==1)
	sc_bit(__eflags,OF,oldsf!=get_bit(__eflags,SF));
sc_bit(__eflags,CF,(res>>(count+1))&0x1);
OP_1=res;
//return 1;
}

int CPU::CPU_subS(){
#if OSIZE
    Bit32u res;
#else
    Bit16u res;
#endif
res = OP_1-OP_2;
set_flags_sub(OP_1,OP_2,res,OP_S1);
OP_1=res;
//return 1;
}

int CPU::CPU_subb(){
Bit8u res;
res = OP_1-OP_2;
set_flags_sub(OP_1,OP_2,res,1);
OP_1=res;
//return 1;
}

//! R
int CPU::CPU_stosS(){
    OP_1=OP_2;
}

//! R
int CPU::CPU_stosb(){
    OP_1=OP_2;
}

int CPU::CPU_seta(){
	exception(EXC_UD);
}

int CPU::CPU_setae(){
	exception(EXC_UD);
}

int CPU::CPU_setb(){
	exception(EXC_UD);
}

int CPU::CPU_setbe(){
	exception(EXC_UD);
}

int CPU::CPU_sete(){
	exception(EXC_UD);
}

int CPU::CPU_setg(){
	exception(EXC_UD);
}

int CPU::CPU_setge(){
	exception(EXC_UD);
}

int CPU::CPU_setl(){
	exception(EXC_UD);
}

int CPU::CPU_setle(){
	exception(EXC_UD);
}

int CPU::CPU_setne(){
	exception(EXC_UD);
}

int CPU::CPU_setno(){
	exception(EXC_UD);
}

int CPU::CPU_setnp(){
	exception(EXC_UD);
}

int CPU::CPU_setns(){
	exception(EXC_UD);
}

int CPU::CPU_seto(){
	exception(EXC_UD);
}

int CPU::CPU_setp(){
	exception(EXC_UD);
}

int CPU::CPU_sets(){
	exception(EXC_UD);
}

int CPU::CPU_sgdt(){
	exception(EXC_UD);
}

int CPU::CPU_sidt(){
	exception(EXC_UD);
}

int CPU::CPU_sldt(){
	exception(EXC_UD);
}

int CPU::CPU_smsw(){
exception(EXC_UD);
}

int CPU::CPU_ss(){
    STH_THIS segment=_ss_;
    i_gonext();
    STH_THIS segment=_zero_;
}

int CPU::CPU_stc(){
stc();
}

int CPU::CPU_std(){
std();
}

int CPU::CPU_sti(){
sti();
}

int CPU::CPU_str(){
	exception(EXC_UD);
}
