#ifndef NEWINLNS_H
#define NEWINLNS_H

#define RM_ISREG() STH_THIS modRMInfo.rm_isreg

extern unsigned long cmds_num;




inline Bit32u CPU::stack_pop32()
{
register Bit32u data;
#if P_MODE==1

#else
    if(STH_THIS amode)
    {
       data=* (Bit32u *) memptr(_SS,_ESP);
       _ESP +=4;
    }
    else
    {
       data=* (Bit32u *) memptr(_SS,_SP);
       _SP +=4;
    }
#endif
return data;
}

inline Bit16u CPU::stack_pop16()
{
register Bit16u data;
#if P_MODE==1

#endif
    if(STH_THIS amode)
    {
       data=*(Bit16u *) memptr(_SS,_ESP);
       _ESP +=2;
    }
    else
    {
       data=*(Bit16u *) memptr(_SS,_SP);
       _SP +=2;
    }
return data;
}


inline int CPU::stack_push32(Bit32u data)
{
#if P_MODE==1

#endif
    if(STH_THIS amode)
    {
    _ESP-=4;
    (*(Bit32u *)memptr(_SS,_ESP))=data;
    }
    else
    {
    _SP-=4;
    (*(Bit32u *)memptr(_SS,_SP))=data;
    }
return 1;
}

inline int CPU::stack_push16(Bit16u data)
{
#if P_MODE==1

#endif
    if(STH_THIS amode)
    {
    _ESP-=2;
    (*(Bit16u *)memptr(_SS,_ESP))=data;
    }
    else
    {
    _SP-=2;
    (*(Bit16u *)memptr(_SS,_SP))=data;
    }
return 1;
}


Bit8u *CPU::CodeInc8()
{
#if P_MODE==1

#endif

#if ! defined (BAD_LVALUE)
  return (Bit8u *)STH_THIS CodePtr++;
#else
  Bit8u *ret=(Bit8u *)
  STH_THIS CodePtr;
  STH_THIS CodePtr++;
  return ret;
#endif
}

Bit16u *CPU::CodeInc16()
{
#if P_MODE==1

#endif

#if ! defined (BAD_LVALUE)
  return ((Bit16u *)STH_THIS CodePtr)++;
#else
  Bit16u *ret=(Bit16u *) STH_THIS CodePtr;
  STH_THIS CodePtr+=2;
  return ret;
#endif
}

Bit32u *CPU::CodeInc32()
{
#if P_MODE==1

#endif

#if ! defined (BAD_LVALUE)
  return ((Bit32u *)STH_THIS CodePtr)++;
#else
  Bit32u *ret=(Bit32u *) STH_THIS CodePtr;
  STH_THIS CodePtr+=4;
  return ret;
#endif
}

void CPU::i_gonext(){
    (STH_WHAT *one_byte_table[*STH_THIS CodeInc8()][STH_THIS osize])();
}

void CPU::i_go(){
/*
// clear some flags
    STH_THIS amode = STH_THIS osize = 
    STH_THIS pref_lock = STH_THIS pref_rep = 0;
    
    STH_THIS segment = _zero_;*/
// make true eip
    sync_eip();
// and now go!    
    i_gonext();
// make true eip    
    sync_eip();
}



/**
   loadModRM_16_16();
   loadModRM_16_32();
   loadModRM_32_16();
   loadModRM_32_32();
**/


void CPU::loadModRM(){
  if(STH_THIS amode){
    STH_THIS modRMInfo=modrm32[ ( STH_THIS modRM = *CodeInc8() )];
    if(STH_THIS modRMInfo.need_sib){
      *(struct SIBinfo *)&STH_THIS modRMInfo=sibInfo[ *CodeInc8()];
      if(STH_THIS modRMInfo.base==0x5 && !(STH_THIS modRM&0xc0)){
	STH_THIS modRMInfo.base=_zero_;
	STH_THIS modRMInfo.disp=4;
      }
    }
    switch(STH_THIS modRMInfo.disp)
      {
      default:
	STH_THIS disp32=0;
	break;
      case 1:
	STH_THIS disp32=(Bit32s)((Bit32s)*CodeInc8());
	break;
      case 4:
	STH_THIS disp32=*CodeInc32();
	break;
      }
  }else{
    STH_THIS modRMInfo=modrm16[ ( STH_THIS  modRM = *CodeInc8() )];
    switch(STH_THIS modRMInfo.disp)
      {
      default:
	STH_THIS disp16=0;
	break;
      case 1:
	STH_THIS disp16=(Bit16s)((Bit8s)*CodeInc8());
	break;
      case 2:
	STH_THIS disp16=*CodeInc16();
	break;
      }
  }
}


#define REG8(n) ((n)<4 ? LOW(STH_THIS Regs[n]): HIGH(STH_THIS Regs[n-4]) )
#define REG16(n) LOWORD(STH_THIS Regs[n])
#define REG32(n) STH_THIS Regs[n]


#define countOFF() (LOWORD(STH_THIS Regs[STH_THIS modRMInfo.base])+	\
	    LOWORD(STH_THIS Regs[STH_THIS modRMInfo.index])+		\
	    STH_THIS disp16)
	    
#define countOFF32() ((STH_THIS Regs[STH_THIS modRMInfo.base])+ \
		      (STH_THIS Regs[STH_THIS modRMInfo.index])*\
		      STH_THIS modRMInfo.scale+STH_THIS disp32)

Bit8u *CPU::countRM(){
  register Bit32u off=0;

  off = STH_THIS amode ? countOFF32() : countOFF();

  if(STH_THIS segment==_zero_){
    if(STH_THIS modRMInfo.base==_ebp_)
      STH_THIS SRegs[_zero_]=_SS;
    else
      STH_THIS SRegs[_zero_]=_DS;
  }
  //  if(segment!=_zero)
  return (Bit8u *)memptr(STH_THIS SRegs[STH_THIS segment],off);
}

Bit8u  *CPU::loadRM8  (){
  if(STH_THIS modRMInfo.rm_isreg)
    return &REG8(STH_THIS modRMInfo.base);
  return (Bit8u *)countRM();
}
Bit16u *CPU::loadRM16 (){
  if(STH_THIS modRMInfo.rm_isreg)
    return &REG16(STH_THIS modRMInfo.base);
  return (Bit16u *)countRM();
}
Bit32u *CPU::loadRM32 (){
  if(STH_THIS modRMInfo.rm_isreg)
    return &REG32(STH_THIS modRMInfo.base);
  return (Bit32u *)countRM();
}


Bit8u  *CPU::loadReg8 (){
  if(STH_THIS modRMInfo.reg<4)
    return &LOW(STH_THIS Regs[STH_THIS modRMInfo.reg]);
  else
    return &HIGH(STH_THIS Regs[STH_THIS modRMInfo.reg-4]);
}
Bit16u *CPU::loadReg16(){
  return &LOWORD(STH_THIS Regs[STH_THIS modRMInfo.reg]);
}
Bit32u *CPU::loadReg32(){
  return &STH_THIS Regs[STH_THIS modRMInfo.reg];
}

Bit16u *CPU::loadSReg(){
  return &STH_THIS SRegs[STH_THIS modRMInfo.reg];
}

Bit32u *CPU::loadCReg(){
  return NULL;
}
Bit32u *CPU::loadDReg(){
  return NULL;
}


Bit8u  *CPU::loadImm8 (){
    return CodeInc8();
}
Bit16u *CPU::loadImm16(){
    return CodeInc16();
}
Bit32u *CPU::loadImm32(){
    return CodeInc32();
}

Bit16u *CPU::loadSib16(){
  static Bit16u sibize;
  sibize=(Bit16u)(*(Bit8s *)CodeInc8());
  return &sibize;
}

Bit32u *CPU::loadSib32(){
  static Bit32u sibize;
  sibize=(Bit32u)(*(Bit8s *)CodeInc8());
  return &sibize;
}

Bit8u  *CPU::load_es_di_8 (){
  if(STH_THIS amode)
    return (Bit8u *)memptr(_ES,get_bit(__eflags,DF)?_EDI--:_EDI++);
  else
    return (Bit8u *)memptr(_ES,get_bit(__eflags,DF)?_DI--:_DI++);
}

Bit16u *CPU::load_es_di_16(){
Bit32u oldr;
  if(STH_THIS amode){
    oldr=_EDI;
    _EDI+=get_bit(__eflags,DF)?-2:2;
    return (Bit16u *)memptr(_ES,oldr);
  }
  else{
    oldr=_DI;
    _DI+=get_bit(__eflags,DF)?-2:2;
    return (Bit16u *)memptr(_ES,oldr);
  }
}

Bit32u *CPU::load_es_di_32(){
Bit32u oldr;

  if(STH_THIS amode){
    oldr=_EDI;
    _EDI+=get_bit(__eflags,DF)?-4:4;
    return (Bit32u *)memptr(_ES,oldr);
  }
  else{
    oldr=_DI;
    _DI+=get_bit(__eflags,DF)?-4:4;
    return (Bit32u *)memptr(_ES,oldr);
  }
}

Bit8u  *CPU::load_ds_si_8 (){
  Bit16u seg;
  Bit32u oldr;

  seg=(STH_THIS segment!=_zero_)? STH_THIS SRegs[STH_THIS segment]:_DS;
  if(STH_THIS amode){
    oldr=_ESI;
    _ESI+=get_bit(__eflags,DF)?-1:1;
    return (Bit8u *)memptr(seg,oldr);
  }
  else{
    oldr=_SI;
    _SI+=get_bit(__eflags,DF)?-1:1;
    return (Bit8u *)memptr(seg,oldr);
  }
}
Bit16u *CPU::load_ds_si_16(){
  Bit16u seg;
  Bit32u oldr;

  seg=(STH_THIS segment!=_zero_)? STH_THIS SRegs[STH_THIS segment]:_DS;
  if(STH_THIS amode){
    oldr=_ESI;
    _ESI+=get_bit(__eflags,DF)?-2:2;
    return (Bit16u *)memptr(seg,oldr);
  }
  else{
    oldr=_SI;
    _SI+=get_bit(__eflags,DF)?-2:2;
    return (Bit16u *)memptr(seg,oldr);
  }
}
Bit32u *CPU::load_ds_si_32(){
  Bit16u seg;
  Bit32u oldr;

  seg=(STH_THIS segment!=_zero_)? STH_THIS SRegs[STH_THIS segment]:_DS;
  if(STH_THIS amode){
    oldr=_ESI;
    _ESI+=get_bit(__eflags,DF)?-4:4;
    return (Bit32u *)memptr(seg,oldr);
  }
  else{
    oldr=_SI;
    _SI+=get_bit(__eflags,DF)?-4:4;
    return (Bit32u *)memptr(seg,oldr);
  }
}

Bit8u  *CPU::loadRel8 (){
  return CodeInc8();
}
Bit16u *CPU::loadRel16(){
  return CodeInc16();
}
Bit32u *CPU::loadRel32(){
  return CodeInc32();
}


// MX is just [DS|prefSEG][offset]
Bit8u  *CPU::loadMX8 (){
Bit16u seg=
    (STH_THIS segment!=_zero_)? STH_THIS SRegs[STH_THIS segment]:_DS;
    if(STH_THIS amode)
	return (Bit8u *)memptr(seg,*CodeInc32());
    else
	return (Bit8u *)memptr(seg,*CodeInc16());
}
Bit16u *CPU::loadMX16(){
Bit16u seg=
    (STH_THIS segment!=_zero_)? STH_THIS SRegs[STH_THIS segment]:_DS;
    if(STH_THIS amode)
	return (Bit16u *)memptr(seg,*CodeInc32());
    else
	return (Bit16u *)memptr(seg,*CodeInc16());
}
Bit32u *CPU::loadMX32(){
Bit16u seg=
    (STH_THIS segment!=_zero_)? STH_THIS SRegs[STH_THIS segment]:_DS;
    if(STH_THIS amode)
	return (Bit32u *)memptr(seg,*CodeInc32());
    else
	return (Bit32u *)memptr(seg,*CodeInc16());
}

//Bit8u  *CPU::loadPtr8 (){
//return STH_THIS CodePtr-4;
//}
Bit16u *CPU::loadPtr16(){
  //  if(STH_THIS amode){
  //	STH_THIS CodePtr+=6;
  //        return (Bit16u *)(STH_THIS CodePtr-6);
  //    }else{
  STH_THIS CodePtr+=4;
  return (Bit16u *)(STH_THIS CodePtr-4);
  //    }
}
Bit32u *CPU::loadPtr32(){
  //  if(STH_THIS amode){
  ///	STH_THIS CodePtr+=6;
  //        return (Bit32u *)STH_THIS CodePtr-6;
  //    }else{
  STH_THIS CodePtr+=6;
  return (Bit32u *)STH_THIS CodePtr-6;
  //    }
}
#endif
