//
// To keep dosemu compatible
//

#ifndef REGS_H
#define REGS_H

//#define LOW(x)   (*(unsigned char *)&(x))
//#define HIGH(x)  (*((unsigned char *)&(x) + 1))
//#define LOWORD(reg)      (*((unsigned short *)&REG(reg)))
//#define HIWORD(reg)      (*((unsigned short *)&REG(reg) + 1))

#define LOW(x)    (*(Bit8u *)&(x))
#define HIGH(x)   (*(((Bit8u *)&(x))+1))
#define LOWORD(x) (*(Bit16u *)&(x))

#define REG(reg) __##reg
#define REG_S(reg) __##reg##_s
#define LO(reg)  (*(unsigned char *)&REG(e##reg))
#define HI(reg)  (*((unsigned char *)&REG(e##reg) + 1))
#define LWORD(reg)      (*((unsigned short *)&REG(reg)))
#define HWORD(reg)      (*((unsigned short *)&REG(reg) + 1))


// "es","cs","ss","ds","fs","gs"
#define _ES /* CPU:: */ STH_THIS SRegs[0]
#define _CS /* CPU:: */ STH_THIS SRegs[1]
#define _SS /* CPU:: */ STH_THIS SRegs[2]
#define _DS /* CPU:: */ STH_THIS SRegs[3]
#define _FS /* CPU:: */ STH_THIS SRegs[4]
#define _GS /* CPU:: */ STH_THIS SRegs[5]

//32
#define _EAX /* CPU:: */STH_THIS Regs[0]
#define _ECX /* CPU:: */STH_THIS Regs[1]
#define _EDX /* CPU:: */STH_THIS Regs[2]
#define _EBX /* CPU:: */STH_THIS Regs[3]
#define _ESP /* CPU:: */STH_THIS Regs[4]
#define _EBP /* CPU:: */STH_THIS Regs[5]
#define _ESI /* CPU:: */STH_THIS Regs[6]
#define _EDI /* CPU:: */STH_THIS Regs[7]
//16
#define _AX (*(Bit16u *)&_EAX)
#define _CX (*(Bit16u *)&_ECX)
#define _DX (*(Bit16u *)&_EDX)
#define _BX (*(Bit16u *)&_EBX)
#define _SP (*(Bit16u *)&_ESP)
#define _BP (*(Bit16u *)&_EBP)
#define _SI (*(Bit16u *)&_ESI)
#define _DI (*(Bit16u *)&_EDI)
//8
#define _AL (*(Bit8u *)&_EAX)
#define _AH (*(((Bit8u *)&_EAX)+1))
#define _CL (*(Bit8u *)&_ECX)
#define _CH (*(((Bit8u *)&_ECX)+1))
#define _DL (*(Bit8u *)&_EDX)
#define _DH (*(((Bit8u *)&_EDX)+1))
#define _BL (*(Bit8u *)&_EBX)
#define _BH (*(((Bit8u *)&_EBX)+1))

//32-s
#define _EAX_S ((Bit32s)_EAX)
#define _ECX_S ((Bit32s)_ECX)
#define _EDX_S ((Bit32s)_EDX)
#define _EBX_S ((Bit32s)_EBX)
#define _ESP_S ((Bit32s)_ESP)
#define _EBP_S ((Bit32s)_EBP)
#define _ESI_S ((Bit32s)_ESI)
#define _EDI_S ((Bit32s)_EDI)
//16
#define _AX_S (*(Bit16s *)&_EAX)
#define _CX_S (*(Bit16s *)&_ECX)
#define _DX_S (*(Bit16s *)&_EDX)
#define _BX_S (*(Bit16s *)&_EBX)
#define _SP_S (*(Bit16s *)&_ESP)
#define _BP_S (*(Bit16s *)&_EBP)
#define _SI_S (*(Bit16s *)&_ESI)
#define _DI_S (*(Bit16s *)&_EDI)
//8
#define _AL_S (*(Bit8s *)&_EAX)
#define _AH_S (*(((Bit8s *)&_EAX)+1))
#define _CL_S (*(Bit8s *)&_ECX)
#define _CH_S (*(((Bit8s *)&_ECX)+1))
#define _DL_S (*(Bit8s *)&_EDX)
#define _DH_S (*(((Bit8s *)&_EDX)+1))
#define _BL_S (*(Bit8s *)&_EBX)
#define _BH_S (*(((Bit8s *)&_EBX)+1))


#define _EFLAGS STH_THIS eflags

#define __es _ES
#define __cs _CS
#define __ss _SS
#define __ds _DS
#define __fs _FS
#define __gs _GS
//32
#define __eax _EAX
#define __ecx _ECX
#define __edx _EDX
#define __ebx _EBX
#define __esp _ESP
#define __ebp _EBP
#define __esi _ESI
#define __edi _EDI
//16
#define __ax  _AX 
#define __cx  _CX 
#define __dx  _DX 
#define __bx  _BX 
#define __sp  _SP 
#define __bp  _BP 
#define __si  _SI 
#define __di  _DI 
//8
#define __al  _AL
#define __ah  _AH 
#define __cl  _CL 
#define __ch  _CH 
#define __dl  _DL 
#define __dh  _DH 
#define __bl  _BL 
#define __bh  _BH 

//32-s
#define __eax_s _EAX_S
#define __ecx_s _ECX_S
#define __edx_s _EDX_S
#define __ebx_s _EBX_S
#define __esp_s _ESP_S
#define __ebp_s _EBP_S
#define __esi_s _ESI_S
#define __edi_s _EDI_S
//16-s
#define __ax_s  _AX_S
#define __cx_s  _CX_S
#define __dx_s  _DX_S
#define __bx_s  _BX_S
#define __sp_s  _SP_S
#define __bp_s  _BP_S
#define __si_s  _SI_S
#define __di_s  _DI_S
//8-s
#define __al_s  _AL_S
#define __ah_s  _AH_S
#define __cl_s  _CL_S
#define __ch_s  _CH_S
#define __dl_s  _DL_S
#define __dh_s  _DH_S
#define __bl_s  _BL_S
#define __bh_s  _BH_S

#define __flags  _FLAGS
#define __eflags _EFLAGS

#define READ_SEG_REG(reg) (__##reg)
#define WRITE_SEG_REG(reg, val) __##reg = (val)

#endif
