// ! 1apsu 2... 3...
// a-auto
// p-pointer
// s-signed	
// u-unsigned
// S-skip
// d-double size???
// default are: 1:pu 2:au 3:au

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <stdlib.h>

#include "cparser.h"

#if 0
FILE *in=stdin;
FILE *out=stdout;
#endif

#define MAX_STR 512
#define COM_C   1
#define COM_CPP 2

char *APPEND(char*dest,int &dest_len,const char *src){
  int len;

  if(!src){
    fprintf(stderr,"APPEND: warning you give me null source\n"
	    "I hope you wouldn't catch 11, so ret\n");
    return dest;
  }
  len=strlen(src)+1;
  if(len==0)
    return dest;

  if(dest)
    dest=(char *)realloc(dest,
			 dest_len+len);
  else{
    dest=(char *)malloc(len);
    dest[0]='\0';
  }
  if(!dest){
    fprintf(stderr,"fatal error: couldn't allocate memory!\n");
    exit(-1);
  }
  strcat(dest,src);
  dest_len+=len;
  return dest;
}

CParser::CParser(){
  prev_file=NULL;
  line=0;
}

//
//	look's for function/struct/class in C/C++ file 'in', and stores
//	it's head, and body in 'func' structure
//	for example: void foo(){
//			}
//	head: void foo()
//	body:  {
//	       }
//
void CParser::find_function(struct function *func,FILE *in){
  char str[MAX_STR];
  int in_comment,in_string,in_char,
    in_body,in_dir;
  int slash,backslash,mul;
  long br_rol; // circular  brackets () counter (++ --)
  long br_tech;// technical brackets {}
  int  i,len;
  int  skip_function=0;

  if(in!=prev_file){
    line=0;
    prev_file=in;
  }

  br_rol=br_tech=line=slash=backslash=mul=in_string=
    in_body=in_char=in_dir=in_comment=0;
  func->body_len=func->head_len=0;
  if(func->head){
    free(func->head);
    func->head=NULL;
  }
  if(func->body){
    free(func->body);
    func->body=NULL;
  }
  for(int i=0;i<3;i++)
    func->prop[i]=0;
  						
  while(fgets(str,MAX_STR,in)){
    len=strlen(str);

    for(i=0,++line;i<len;i++)
      {				
	switch(str[i]){	
	case '(':
	  if(!in_comment && !in_string && !in_char)
	    br_rol++;
	  break;
	case ')':
	  if(!in_comment && !in_string && !in_char)
	    br_rol--;
	  break;
	case '{':
	  if(!in_comment && !in_string && !in_char)
	    br_tech++;
	  break;
	case '}':
	  if(!in_comment && !in_string && !in_char)
	    br_tech--;
	  break;    	
	case '\'':
	  if(!in_comment && ! backslash && !in_string) // look's like :)
	    in_char^=1;
	  backslash=0;
	  break;
	case '#':
	  if(!in_comment && ! in_string && !in_char)
	    in_dir=1;
	    break;
	case '\"':
	  if(!in_comment && !backslash && !in_char)
	    in_string^=1;
	  backslash=0;
	  break;
	case '\\':
	  backslash^=1; // \ 1, \\ -0, \\\ -1
	  break;				 
	case '/':
	  if(!in_string && !in_comment && str[i+1]=='/'){
	    slash=0;
	    in_comment=COM_CPP;
	    i++;
	  }else if(!in_comment && !in_string && str[i+1]=='*'){
	    i++;			
	    slash=0;
	    in_comment=COM_C;
	  }else if( (in_comment&COM_C) && mul)
	    in_comment=0;
	  else
	    slash=1;
	  break;
	case '*':
	  mul=1;
	  break;
	case '\n':
	  break;
	default:
	  slash=mul=backslash=0;
	}



	if(in_comment&COM_CPP)
	  break;
      }
    // look for special C++ comment
    if(in_comment&COM_CPP && str[i+1]=='!')
      skip_function=do_options(str+i+1,func)==1;
    else{
      if(!in_body && br_tech>0){ // we got head
	//	    func
	in_body=1;
	func->line=line;
	func->body=APPEND(func->body,func->body_len,strchr(str,'{')+1);
	*strchr(str,'{')=0;
	func->head=APPEND(func->head,func->head_len,str);
      }else if(in_body)
	func->body=APPEND(func->body,func->body_len,str);
      else if(!in_dir){
	if(in_comment&COM_CPP)
	  *str='\0';
	func->head=APPEND(func->head,func->head_len,str);
      }
    }
    in_comment&=~COM_CPP;  // C++ comments ends when line ends
    in_dir=0;
    if(in_body && !br_tech){// so here we got function's end
      *strrchr(func->body,'}')=0;
      break;// and go down
    }
  }
  if(br_rol || br_tech)
    fprintf(stderr,"Look's like syntax error!\n");
  if(in_string)
    fprintf(stderr,"Don't forget close string!\n");

  // delete all '\n' 's from head
  for(i=0;i<func->head_len;i++)
    if(func->head[i]=='\n')
      func->head[i]=' ';
  if(skip_function)
    find_function(func,in);

}

//
// extract function name from head without class name if any
//
// it have bugs:
// for example    "(void *) func()"
// it will return ""
char *CParser::extract_name(char *head){
  int i,j,len;
  static char ret[100];
  len=strlen(head);

  for(i=0;i<len;i++)
      if(head[i]=='(')
	break;

  for(j=i;j>0;j--)
    if(head[j]==' ' || head[j]=='\t' || head[j]=='\n' || head[j]=='*' ||
       head[j]=='&' || head[j]==':'){
      j++;
      break;
      }
  strncpy(ret,head+j,i-j);
  ret[i-j]='\0';
  return ret;
}

int CParser::do_options(char *,struct function *){
  return 0;
}


#if 0
int main(){
  struct function func;

  func.body=func.head=NULL;
  while(!feof(in)){
    find_function(&func,in);
    if(func.head && func.body)
      printf("head:%s\nbody:\n%s\n",func.head,func.body);
    else 
     break;
    }
}

#endif
