
//
//	this should be rewritten using lex+yacc
//


#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <stdlib.h>

#include "disasm.h"
#include "dis386.h"

#include "cparser.h"

#define CMDS_DIR "./cmds"

#define PROP_SIGNED    0x1
#define PROP_AUTO      0x2
#define PROP_REGISTER  0x10

#define PROP_REP       0x100
#define PROP_REPCOND   0x200

#define SIGN_SET      0x1000
#define AUTO_SET      0x2000

//#define PROP_UNSIGNED (~PROP_SIGNED)
//#define PROP_AUTO     (~PROP_POINTER)
//#define PROP_POINTER  0x2

static struct dis386 *full;
static int full_len = 0;

const Bit32u is_twobyte = 0x10000000;
const Bit32u is_grp = 0x20000000;

char *
genArgStr (struct dis386 *d, int opsize)
{
  static char __buf[100];
  char tmp[20];
  __buf[0] = '\0';
  for (int i = 0; i < 3; i++)
    {
      switch (d->op[i] & _gmask)
	{
	case _grm:
	  strcat (__buf, "_rm");
	  break;
	case _greg:
	  switch (d->op[i] & _regMask)
	    {
	    case _rcommon:
	      strcat (__buf, "_reg");
	      break;
	    case _rseg:
	      strcat (__buf, "_sreg");
	      break;
	    case _rdbg:
	      strcat (__buf, "_dreg");
	      break;
	    case _rctrl:
	      strcat (__buf, "_creg");
	      break;
	    }
	  break;
	case _gimm:
	  if (d->op[i] & _gsign)
	    strcat (__buf, "_sib");
	  else if (d->op[i] & _haveNb)
	    strcat (__buf, "_imm");
	  else
	    strcat (__buf, "_1");
	  break;
	case _grel:
	  strcat (__buf, "_rel");
	  break;
	case _gstr:
	  strcat (__buf, "_str");
	  break;
	case _ghreg:
	  switch (d->op[i] & _regMask)
	    {
	    case _rcommon:
	      //	      strcat (__buf, "_hreg");
	      switch(d->opSize[i][opsize]){
	      case 1:
		sprintf (tmp, "_%s",_reg_names[d->op[i] & 0x7].reg[0]);
		break;
	      case 2:
		sprintf (tmp, "_%s",_reg_names[d->op[i] & 0x7].reg[1]);
		break;
	      case 4:
		sprintf (tmp, "_%s",_reg_names[d->op[i] & 0x7].reg[2]);
		break;
	      default:
	        sprintf (tmp, "_FixMe!!!");
	      }
	      
	      break;
	    case _rseg:
	      sprintf (tmp, "_%s",_segreg_names[d->op[i] & 0x3]);
	      break;
	    case _rdbg:
	      sprintf (tmp, "_dr%l",(d->op[i]&0x7));
	      break;
	    case _rctrl:
	      sprintf (tmp, "_cr%l",(d->op[i]&0x7));
	      break;
	    }
	  strcat(__buf,tmp);
	  break;
	case _gmx:
	  strcat (__buf, "_mx");
	  break;
	case _gptr:
	  strcat (__buf, "_ptr");
	  break;
	case _gregGate:
	  strcat (__buf, "_regGate");
	  break;
	case _gtwobyte:
	  strcat (__buf, "_twobyte");
	  break;
	case _gno:
	  i = 3;
	  break;
	default:
	  fprintf (stderr, "Warning: unhandled group for: %s\n",
		   d->name ? d->name : "NULL");
	  sprintf (__buf, "FixMe");
	};
    }
  return __buf;
}

class NewHandler:public CParser
{
public:
  void do_body (struct dis386 *, struct function *, int, int, int);
  void genHandler (struct dis386 *, struct function *, int , int = 0);
  void do_file (FILE *, char *);
  int do_options (char *, struct function *);
  void do_stuff ();
  void parse_options (struct function *func, struct dis386 *d);
    virtual ~ NewHandler ();
    NewHandler ();
private:
  FILE *out;

  FILE *out16;
  FILE *out32;

  FILE *out16pm;
  FILE *out32pm;

  FILE *header;
  char filename[100];
};

int
Compare (struct dis386 *s1, struct dis386 *s2)
{
  return strcoll (s1->name, s2->name);
}

// find item `name' in `full'
// and return it's number
int
find_item (char *name, int n = -1)
{
  for (++n; n < full_len; n++)
    if (!strcmp (full[n].name, name))
      return n;
  return -1;
}

NewHandler::NewHandler ()
{
  header = fopen ("nhandlers.h", "w");
  out16 = fopen ("16bit.cpp", "w");
  out32 = fopen ("32bit.cpp", "w");
  out16pm = fopen ("16bit-pm.cpp", "w");
  out32pm = fopen ("32bit-pm.cpp", "w");
  
    if(!out16 || !out32 || !out16pm || !out32pm)
	{
	    fprintf(stderr,"Couldn't create some files...\n");
	    exit(-1);
	}
  
  fprintf (out16, "// Copyright(c) 2003 Vitja Makarov\n"
  	   "#define OSIZE  0\n" 
	   "#define P_MODE 0\n\n"
	   "#include \"cpu.h\"\n"
	   "#include \"newinls.h\"\n\n");
  fprintf (out32, "// Copyright(c) 2003 Vitja Makarov\n"
  	   "#define OSIZE  1\n" 
	   "#define P_MODE 0\n\n"
	   "#include \"cpu.h\"\n"
	   "#include \"newinls.h\"\n\n");
  fprintf (out16pm, "// Copyright(c) 2003 Vitja Makarov\n"
  	   "#define OSIZE  0\n" 
	   "#define P_MODE 1\n\n"
	   "#include \"cpu.h\"\n"
	   "#include \"newinls.h\"\n\n");
  fprintf (out32pm, "// Copyright(c) 2003 Vitja Makarov\n"
  	   "#define OSIZE  1\n" 
	   "#define P_MODE 1\n\n"
	   "#include \"cpu.h\"\n"
	   "#include \"newinls.h\"\n\n");

}

NewHandler::~NewHandler ()
{
  if (out16)
    fclose (out16);
  if (out32)
    fclose (out32);
  if (header)
    fclose (header);
}

int
NewHandler::do_options (char *line, struct function *func)
{
  int len;
  int j = 0;
  int skip_function = 0;
  len = strlen (line);
  for (; * line ;)
    switch (*line++)
      {
      case '1':
	j = 0;
	break;
      case '2':
	j = 1;
	break;
      case '3':
	j = 2;
	break;
      case 'a':
	func->prop[j] |= PROP_AUTO | AUTO_SET;
	break;
      case 'p':
	func->prop[j] &= ~PROP_AUTO;
	func->prop[j] |= AUTO_SET;
	break;
      case 's':
	func->prop[j] |= PROP_SIGNED | SIGN_SET;
	break;
      case 'u':
	func->prop[j] &= ~PROP_SIGNED;
	func->prop[j] |= SIGN_SET;
	break;
      case 'S':
	skip_function = 1;
	break;
      case 'R':  /* rep */
	func->prop[0] |= PROP_REP;
        break;
      case 'C': /* cond rep */
        func->prop[0] |= PROP_REPCOND;
	break;
      }

  return skip_function;
}

int
getOpSize (struct dis386 *d, int i, int oSize = 0)
{
  return d->opSize[i][oSize ? 1 : 0];
}

#define PROP_IMM  (PROP_AUTO/*|PROP_REGISTER*/)
#define PROP_RM   (0/*|PROP_REGISTER*/)
#define PROP_REG  (0/*|PROP_REGISTER*/)
#define PROP_SIB  (/*PROP_SIGNED|PROP_REGISTER|*/PROP_AUTO)
#define PROP_REL  (PROP_SIGNED/*|PROP_REGISTER*/|PROP_AUTO)


void
NewHandler::parse_options (struct function *func, struct dis386 *d)
{
  Bit32u def;
  for (int i = 0; i < 3; i++)
    {
      switch (d->op[i] & _gmask)
	{
	case _gimm:
	  if (d->op[i] & _gsign)
	    def = PROP_SIB;
	  else
	    def = PROP_IMM;
	  break;
	case _grm:
	  def = PROP_RM;
	  break;
	case _greg:
	  def = PROP_REG;
	  break;
	case _grel:
	  def = PROP_REL;
	  break;
	  /*    case _gimm:
	     def=PROP_IMM;
	     break; */
	default:
	  def = 0;
	}
      if (func->prop[i] & SIGN_SET)
	{
	  if (func->prop[i] & PROP_SIGNED)
	    def |= PROP_SIGNED;
	  else
	    def &= ~PROP_SIGNED;
	}
      if (func->prop[i] & AUTO_SET)
	{
	  if (func->prop[i] & PROP_AUTO)
	    def |= PROP_AUTO;
	  else
	    def &= ~PROP_AUTO;
	}
      if(func->prop[i] & PROP_REP)
        def|=PROP_REP;
      else if(func->prop[i] & PROP_REPCOND)
        def|=PROP_REPCOND;

      func->prop[i] = def;
    }


}

// do new body + old code
void
NewHandler::do_body (struct dis386 *d, struct function *_func,
		     int modrm_loaded, int osize, int pm)
{
  struct function func = *_func;
  int opSize[3];
  parse_options (&func, d);

  for (int i = 0; i < 3; i++)
    {
      opSize[i] = getOpSize (d, i, osize);
      if (opSize[i])
	fprintf (out, "#define OP_S%d %d\n", i + 1, opSize[i]);
    }
  //  fprintf(stderr,"%d\t%d\t%d\n",opSize[0],opSize[1],opSize[2]);
  for (int i = 0; i < 3; i++)
    if (opSize[i])
      {
	if ((d->op[i] & _gmask) == _ghreg)
	  {
	    switch (d->op[i] & _regMask)
	      {
	      case _rcommon:
		switch (opSize[i])
		  {
		  case 1:
		    fprintf (out, "#define OP_%d ( REG%s(%s) )\n", i + 1,
			     func.prop[i] & PROP_SIGNED ? "_S" : "",
			     _reg_names[d->op[i] & 0x7].reg[0]);
		    break;
		  case 2:
		    fprintf (out, "#define OP_%d ( REG%s(%s) )\n", i + 1,
			     func.prop[i] & PROP_SIGNED ? "_S" : "",
			     _reg_names[d->op[i] & 0x7].reg[1]);
		    break;
		  case 4:
		    fprintf (out, "#define OP_%d ( REG%s(%s) )\n", i + 1,
			     func.prop[i] & PROP_SIGNED ? "_S" : "",
			     _reg_names[d->op[i] & 0x7].reg[2]);
		    break;
		  }
		break;
	      case _rseg:
		fprintf (out, "#define OP_%d ( REG(%s) )\n", i + 1,
			 _segreg_names[d->op[i] & 0x3]);
		break;
	      case _rdbg:
		break;
	      case _rctrl:
		break;
	      }
	  }
	else if ( (d->op[i] & _gmask)==_gimm && !(d->op[i]&_haveNb) )
	    fprintf (out, "#define OP_%d 1\n",
		     i + 1);
	else
	    fprintf (out, "%sBit%d%c %sop_%d_p;\n"
		     "#define OP_%d (%sop_%d_p)\n",
		     (func.prop[i]&PROP_REGISTER)? "register " : "",
		      opSize[i] * 8, func.prop[i] & PROP_SIGNED ? 's' : 'u'
		       , (func.prop[i]&PROP_AUTO) ? "" : "*",i+1, i + 1
		      ,func.prop[i]&PROP_AUTO?"":"*",i + 1);
      }

  if (d->haveMod && !modrm_loaded)
    fprintf (out, "STH_THIS loadModRM();\n");

// here do the rep stuff
    if(func.prop[0] & (PROP_REP|PROP_REPCOND))
    {
	fprintf(out, "  if(STH_THIS pref_rep)\n"
		"  {\n"
    		"    if(STH_THIS amode)\n"
		"	{\n"
		"	    if(!_ECX)\n"
		"		return;\n"
		"	}else{\n"
		"	    if(!_CX)\n"
		"		return;\n"
		"	}\n"
		" }\n"
		"\n"
		"next:\n"
		);
    }


  // load operands
  for (int i = 0; i < 3 && d->op[i]; i++)
    {
     if ( (d->op[i] & _gmask)==_gimm && !(d->op[i]&_haveNb))
      continue;
      if ((d->op[i] & _gmask) != _ghreg)
	fprintf (out, "op_%d_p=%s(Bit%d%c *)STH_THIS ", i + 1,
	func.prop[i]&PROP_AUTO?"*":"", opSize[i] * 8,
		 func.prop[i] & PROP_SIGNED ? 's' : 'u');
      switch (d->op[i] & _gmask)
	{
	case _gimm:
	  if (d->op[i] & _gsign)
	    fprintf (out, "loadSib%d();\n", opSize[i] * 8 );
	  else
	    fprintf (out, "loadImm%d();\n", opSize[i] * 8 );
	  break;
	case _greg:
	  switch (d->op[i] & _regMask)
	    {
	    case _rcommon:
	      fprintf (out, "loadReg%d();\n", opSize[i] * 8 );
	      break;
	    case _rseg:
	      fprintf (out, "loadSReg();\n" );
	      break;
	    case _rdbg:
	      fprintf (out, "loadDReg();\n" );
	      break;
	    case _rctrl:
	      fprintf (out, "loadCReg();\n");
	      break;
	    }
	  break;
	case _grel:
	  fprintf (out, "loadRel%d();\n", opSize[i] * 8);
	  break;
	case _gmx:
	  fprintf (out, "loadMX%d();\n", opSize[i] * 8 );
	  break;
	case _gptr:
	  fprintf (out, "loadPtr%d();\n", opSize[i] * 8 );
	  break;
	case _gstr:
	  if (d->op[i] & 0xf)
	    fprintf (out, "load_es_di_%d();\n", opSize[i] * 8);
	  else
	    fprintf (out, "load_ds_si_%d();\n", opSize[i] * 8);
	  break;
	case _grm:
	  fprintf (out, "loadRM%d();\n", opSize[i] * 8);
	  break;
	case _ghreg:
	  break;
	case _gno:
	  break;
	default:
	  fprintf (stderr, "Undefined group for `%s', group ID=0x%08lx\n",
		   d->name, d->op[i] & _gmask);
	}
    }
//  fprintf(out,"#line %d \"%s\"",func.line,filename);
  fprintf(out, "%s",func.body);

    if(func.prop[0] & PROP_REP)
    {
	fprintf(out,
"    if(STH_THIS pref_rep)\n"
"    {\n"
"	if(STH_THIS amode)\n"
"	{\n"
"	    if(!(--_ECX))\n"
"		return;\n"
"	}else{\n"
"	    if(!(--_CX))\n"
"		return;\n"
"	}\n"
// "#ifdef MIPS_COUNTER\n"
// " 	        cmds_num++;\n"
// "#endif\n"
"      goto next;\n"
"    }\n"
		    );
	


    }
    else if(func.prop[0] & PROP_REPCOND)
    {
        fprintf(out, 
"    switch(STH_THIS pref_rep)\n"
"    {\n"
"    default:\n"
"	return;\n"
"    case 1:\n"
"	if(STH_THIS amode)\n"
"	{\n"
"	    if(!(--_ECX) || !get_bit(__eflags, ZF))\n"
"		return;\n"
"	    else{\n"
// "#ifdef MIPS_COUNTER\n"
// " 	        cmds_num++;\n"
// "#endif\n"
"		goto next;\n"
"		}\n"
"	}else{\n"
"	    if(!(--_CX)  || !get_bit(__eflags, ZF))\n"
"		return;\n"
"	    else{\n"
// "#ifdef MIPS_COUNTER\n"
// " 	        cmds_num++;\n"
// "#endif\n"
"		goto next;\n"
"		}\n"
"	}\n"
"    case 2:\n"
"	if(STH_THIS amode)\n"
"	{\n"
"	    if(!(--_ECX) || get_bit(__eflags, ZF))\n"
"		return;\n"
"	    else{\n"
// "#ifdef MIPS_COUNTER\n"
// " 	        cmds_num++;\n"
// "#endif\n"
"		goto next;\n"
"		}\n"
"	}else{\n"
"	    if(!(--_CX)  || get_bit(__eflags, ZF))\n"
"		return;\n"
"	    else{ \n"
// "#ifdef MIPS_COUNTER\n"
// "	        cmds_num++;\n"
// "#endif\n"
"		goto  next;\n"
"		}\n"
"	}\n"
"    }	\n"
		    );	
    }
  
  
  fprintf (out,
	   "#undef OP_1\n"
	   "#undef OP_2\n"
	   "#undef OP_3\n" "#undef OP_S1\n#undef OP_S2\n#undef OP_S3\n");

}

void
NewHandler::genHandler (struct dis386 *d, struct function *func, int o32 , int pm)
{
  char name[100];
  char *argstr;
  // handler's name
  if (d->add & is_grp)
    sprintf (name, "%s_grp%ld_%ld%s", d->name,
	     (d->add & 0xff00) / 0x100, d->add & 0xff, pm ? "_pm" : "");
  else if (d->add & is_twobyte)
    sprintf (name, "%s_%04lx%s", d->name, d->add & 0xffff, pm ? "_pm" : "");
  else				/* one byte */
    sprintf (name, "%s_%02lx%s", d->name, d->add & 0xff, pm ? "_pm" : "");

  argstr = genArgStr (d,o32);
  if (header)
    fprintf (header, "STH_PREF void i_%s_%d();\n", 
	    name, o32 ? 32 : 16);

  fprintf (out, "#define __%s%s__\n"
	   "void CPU::i_%s_%d(){\n", d->name, argstr,
	    name, o32 ? 32 : 16);
	    
  do_body (d, func, d->add & is_grp, o32, pm);

  fprintf (out, "}\n" "#undef __%s%s__\n\n", d->name, argstr);

}

void
NewHandler::do_file (FILE * fp,char *filename)
{
  struct function func;
  char *name;
  int item_n = 0;
  func.head = NULL;
  func.body = NULL;
  
  strcpy(NewHandler::filename, filename);
  for (;;)
    {				// do next function
      find_function (&func, fp);
      if (!func.head || !func.body)	// nothing more to do
	return;
      name = extract_name (func.head);
      // and now find 'name' in 'full'
#if 0
      name += 4;		// all names are CPU_xxxxx
#else
      if (strstr (name, "CPU_"))
	name += 4;
#endif


      for (item_n = -1; (item_n = find_item (name, item_n)) >= 0;)
	{
	  out = out16;
	  genHandler (&full[item_n], &func, 0);
	  out = out32;
	  genHandler (&full[item_n], &func, 1);
	  out = out16pm;
	  genHandler (&full[item_n], &func, 0 , 1);
	  out = out32pm;
	  genHandler (&full[item_n], &func, 1 , 1);
	}
    }
}

void
NewHandler::do_stuff ()
{
  // create header entries
  if (header)
    fprintf (header,
	     "STH_PREF void i_bad_opcode_16();\n"
	     "STH_PREF void i_twobyte_esc_16();\n"
	     "STH_PREF void i_bad_opcode_32();\n" 
	     "STH_PREF void i_twobyte_esc_32();\n"
	     "STH_PREF void i_bad_opcode_pm_16();\n"
	     "STH_PREF void i_twobyte_esc_pm_16();\n"
	     "STH_PREF void i_bad_opcode_pm_32();\n" 
	     "STH_PREF void i_twobyte_esc_pm_32();\n");
	     
  fprintf (out16, "void CPU::i_twobyte_esc_16(){\n"
	   "(STH_WHAT *(two_byte_table[*CodeInc8()][OSIZE]))();\n"
	   "}\n" "void CPU::i_bad_opcode_16(){exception(EXC_UD);}\n");
  fprintf (out32, "void CPU::i_twobyte_esc_32(){\n"
	   "(STH_WHAT *(two_byte_table[*CodeInc8()][OSIZE]))();\n"
	   "}\n" "void CPU::i_bad_opcode_32(){exception(EXC_UD);}\n");

  fprintf (out16pm, "void CPU::i_twobyte_esc_pm_16(){\n"
	   "(STH_WHAT *(two_byte_table[*CodeInc8()][OSIZE+2]))();\n"
	   "}\n" "void CPU::i_bad_opcode_pm_16(){exception(EXC_UD);}\n");
	   
  fprintf (out32pm, "void CPU::i_twobyte_esc_pm_32(){\n"
	   "(STH_WHAT *(two_byte_table[*CodeInc8()][OSIZE+2]))();\n"
	   "}\n" "void CPU::i_bad_opcode_pm_32(){exception(EXC_UD);}\n");
	   
  for (int i = 0; i < 20; i++)
    {
      if (header)
	fprintf (header, "STH_PREF void i_grp_%d_16();\n"
			 "STH_PREF void i_grp_%d_32();\n"
			 "STH_PREF void i_grp_%d_pm_16();\n"
			 "STH_PREF void i_grp_%d_pm_32();\n",
			  i + 1, i + 1, i + 1, i + 1);
      if (out16)
	fprintf (out16, "void CPU::i_grp_%d_16(){\n"
		 "loadModRM();\n"
		 "(STH_WHAT *(grp_table[%d][STH_THIS modRMInfo.reg][OSIZE]))();\n"
		 "}\n", i + 1, i);
      if (out32)
	fprintf (out32, "void CPU::i_grp_%d_32(){\n"
		 "loadModRM();\n"
		 "(STH_WHAT *(grp_table[%d][STH_THIS modRMInfo.reg][OSIZE]))();\n"
		 "}\n", i + 1, i);
      if (out16pm)
	fprintf (out16pm, "void CPU::i_grp_%d_pm_16(){\n"
		 "loadModRM();\n"
		 "(STH_WHAT *(grp_table[%d][STH_THIS modRMInfo.reg][OSIZE+2]))();\n"
		 "}\n", i + 1, i);
      if (out32pm)
	fprintf (out32pm, "void CPU::i_grp_%d_pm_32(){\n"
		 "loadModRM();\n"
		 "(STH_WHAT *(grp_table[%d][STH_THIS modRMInfo.reg][OSIZE+2]))();\n"
		 "}\n", i + 1, i);

    }

}

void
do_htable_entry (struct dis386 *d, FILE * out, int opcode, int two_byte = 0)
{

  if (d->name && d->name[0])
    {
      if (d->name[0] == '(')
	goto bad;
      if (two_byte)
	fprintf (out, 
	    "{&CPU::i_%s_0f%02x_16\t,\t&CPU::i_%s_0f%02x_32,"
	    "&CPU::i_%s_0f%02x_pm_16\t,\t&CPU::i_%s_0f%02x_pm_32},\n",
		 d->name, opcode,
		 d->name, opcode,
		 d->name, opcode,
		 d->name, opcode);
      else
	fprintf (out, 
	    "{&CPU::i_%s_%02x_16\t,\t&CPU::i_%s_%02x_32,"
	    "&CPU::i_%s_%02x_pm_16\t,\t&CPU::i_%s_%02x_pm_32},\n",
		 d->name, opcode,
		 d->name, opcode,
		 d->name, opcode,
		 d->name, opcode);
    }
  else
    {
      if ((d->op[0] & _gmask) == _gregGate)
	fprintf (out, 
	"{&CPU::i_grp_%ld_16\t,\t&CPU::i_grp_%ld_32,"
	"&CPU::i_grp_%ld_pm_16\t,\t&CPU::i_grp_%ld_pm_32},\n",
		 (d->op[2] & 0xff) + 1,
		 (d->op[2] & 0xff) + 1,
		 (d->op[2] & 0xff) + 1,
		 (d->op[2] & 0xff) + 1);
		 
      else if (opcode == 0x0f)
	fprintf (out, 
	"{&CPU::i_twobyte_esc_16\t,&CPU::i_twobyte_esc_32,"
	"&CPU::i_twobyte_esc_pm_16\t,&CPU::i_twobyte_esc_pm_32},\n");
      else
	goto bad;
    }
  return;
bad:
  fprintf (out, 
		"{&CPU::i_bad_opcode_16\t,&CPU::i_bad_opcode_32\t,"
                "&CPU::i_bad_opcode_pm_16\t,&CPU::i_bad_opcode_pm_32\t},\n");
  return;

}


int
main ()
{
  int full_size = sizeof (dis386) + sizeof (grps) + sizeof (dis386_twobyte);
  int j = 0;
  char filename[100];
  FILE *htable;
  NewHandler hands;
  full = (struct dis386 *) malloc (full_size);
  htable = fopen ("htable.cpp", "w");

  memset (full, 0, full_size);
  if (htable)
    {
      fprintf (htable, "#include \"cpu.h\"\n\n");
      fprintf (htable, "/* const */ NewHandler one_byte_table[0x100][4]={\n");
    }
  // and now fill it with dis386 entries      
  for (int i = 0; i < 0x100; i++)
    {
      if (htable)
	do_htable_entry (&dis386[i], htable, i, 0);
      // is it valid ?
      if (dis386[i].name && dis386[i].name[0] != '(' && dis386[i].name[0])
	{
	  full[j] = dis386[i];
	  full[j++].add = i;
	}
    }
  if (htable)
    fprintf (htable, "};\n" "/* const */ NewHandler two_byte_table[0x100][4]={\n");
  // two byte
  for (int i = 0; i < 0x100; i++)
    {
      if (htable)
	do_htable_entry (&dis386_twobyte[i], htable, i, 1);
      if (dis386_twobyte[i].name && dis386_twobyte[i].name[0] != '('
	  && dis386_twobyte[i].name[0])
	{
	  full[j] = dis386_twobyte[i];
	  full[j++].add = 0x0f00 | is_twobyte + i;
	}
    }
  if (htable)
    {
      fprintf (htable, "};\n");

      fprintf (htable, "/* const */ NewHandler grp_table[20][8][4]={\n");
    }

  for (int i = 0; i < 20; i++)
    {
      if (htable)
	fprintf (htable, "{\n");
      for (int l = 0; l < 8; l++)
	{
	  if (grps[i][l].name && grps[i][l].name[0] != '('
	      && grps[i][l].name[0])
	    {
	      full[j] = grps[i][l];
	      full[j++].add = is_grp | (0x100 * (i + 1) + l);
	      if (htable)
		fprintf (htable,
			 "{&CPU::i_%s_grp%d_%d_16\t,&CPU::i_%s_grp%d_%d_32\t},\n",
			 grps[i][l].name, i + 1, l, grps[i][l].name, i + 1,
			 l);
	    }
	  else if (htable)
	    fprintf (htable,
		     "{&CPU::i_bad_opcode_16\t,&CPU::i_bad_opcode_32\t},\n");

	}
      if (htable)
	fprintf (htable, "},\n");
    }
  if (htable)
    fprintf (htable, "};\n");

  full_len = j;
  qsort ((void *) full, full_len, sizeof (struct dis386),
	 (int (*)(const void *, const void *)) Compare);

  char c = '3';			// 3dnow
  FILE *fp;

  for (int i = 0; c <= 'z'; i++)
    {
      // file open loop  
      sprintf (filename, "%s/cmds_%c.cpp", CMDS_DIR, c);

      if ((fp = fopen (filename, "r")))
	{
	  hands.do_file (fp,filename);
	  fclose (fp);
	}
      c = i + 'a';
    }
  hands.do_stuff ();
  if (htable)
    fclose (htable);
  
  free(full);
  return 0;
}
