//
// this program should create C++ file, that will contain big disassembler's 
// case, writing it manually is so lazy...
//
// it will be something like this:
//
//	switch(nextbyte()){
//	case XX:
//	loadmodrm();
//	decode__rm_reg();
//	break;
//	...
//	case 0x0f:
//	decode_twobyte();
//	break;
//	}
//
//
//
//

#include <stdio.h>
#include <string.h>

#include "disasm.h"
#include "dis386.h"

FILE *out=stdout;

void genCase(struct dis386 d,int opcode,int modrmloaded=0){
char handler[100]="";
int i;
fprintf(out,"\tcase 0x%02x:/* %s */ \n",opcode,d.name?d.name:"");
    if(!modrmloaded && d.haveMod)
	fprintf(out,"\tloadmodrm();\n");
// so we have modrm loaded, and now decode stuff
    for(i=0;i<3;i++){
    switch(d.op[i]&_gmask)
        {
	case _grm:
	strcat(handler,"_rm");
	break;
	case _greg:
	strcat(handler,"_reg");
	break;
	case _gimm:
	strcat(handler,"_imm");
	break;
	case _grel:
	strcat(handler,"_rel");
	break;
	case _gstr:
	strcat(handler,"_str");
	break;
	case _ghreg:
	strcat(handler,"_hreg");
	break;
	case _gmx:
	strcat(handler,"_mx");
	break;
	case _gptr:
	strcat(handler,"_ptr");
	break;
//	case _gregGate:
//		strcat(handler,"_regGate");
//	break; 
//	case _gtwobyte:
//		strcat(handler,"_twobyte");
//	break;    
	case _gno:
	i=3;
	break;
        default:
#if 0	
	fprintf(stderr,"Warning: unhandled group for: %s\n" ,d.name?d.name:"NULL");
	sprintf(handler,"FixMe");
#else
	i=3;
#endif	
	};
    }
	if(opcode==0x0f)
	  fprintf(out,"\tdecode_begin_twobyte();\n");
	else if( (d.op[0]&_gmask) == _gregGate)
	  fprintf(out,"\tdecode_begin_grp%ld();\n",1+d.op[2]);
	if(handler[0])
	    fprintf(out,"\tdecode_%s();\n",handler);
// check for prefixes	    
	if(d.name && d.name[0])
	    if(!strcmp(d.name,"es")){
		fprintf(out,"\tcom.pref_seg=_es_;\n");
		fprintf(out,"\tgoto again;\n");
		return;	    
	    }else if(!strcmp(d.name,"cs")){
		fprintf(out,"\tcom.pref_seg=_cs_;\n");
		fprintf(out,"\tgoto again;\n");
		return;	    
	    }else if(!strcmp(d.name,"ss")){
		fprintf(out,"\tcom.pref_seg=_ss_;\n");
		fprintf(out,"\tgoto again;\n");
		return;	    
	    }else if(!strcmp(d.name,"ds")){
		fprintf(out,"\tcom.pref_seg=_ds_;\n");
		fprintf(out,"\tgoto again;\n");
		return;	    
	    }else if(!strcmp(d.name,"fg")){
		fprintf(out,"\tcom.pref_seg=_fs_;\n");
		fprintf(out,"\tgoto again;\n");
		return;	    
	    }else if(!strcmp(d.name,"gs")){
		fprintf(out,"\tcom.pref_seg=_gs_;\n");
		fprintf(out,"\tgoto again;\n");
		return;	    
	    }else if(!strcmp(d.name,"o32")){
		fprintf(out,"\tcom.osize=bitD?0:1;\n");
		fprintf(out,"\tgoto again;\n");
		return;	    
	    }else if(!strcmp(d.name,"a32")){
		fprintf(out,"\tcom.amode=bitD?0:1;\n");
		fprintf(out,"\tgoto again;\n");
		return;	    
	    }else if(!strcmp(d.name,"lock")){
		fprintf(out,"\tcom.pref_lock=1;\n");
		fprintf(out,"\tgoto again;\n");
		return;	    
	    }else if(!strcmp(d.name,"repne")){
		fprintf(out,"\tcom.pref_rep=REPNE_NUM;\n");
		fprintf(out,"\tgoto again;\n");
		return;	    
	    }else if(!strcmp(d.name,"repz")){
    		fprintf(out,"\tcom.pref_rep=REP_NUM;\n");
		fprintf(out,"\tgoto again;\n");
		return;
	    }


	
fprintf(out,"\tbreak;\n");
}

int disasm::parse_next(){return 0;};

int main(){
fprintf(out,"// this file was generated by caser - so edit it manually isn't "
	    "good idea\n"
	    "// \t\t\t\t\t\t\t- better edit caser \n"
	    "// Copyright (c) 2003, Vitja Makarov\n"
	    "// Is funny that autofile can have copyrights\n"
	    );
fprintf(out,"#include <stdio.h>\n");	    
fprintf(out,"#include <string.h>\n");	    
fprintf(out,"#include \"disasm.h\"\n");	    
fprintf(out,"#include \"dis386.h\"\n");	    
// decode_begin
fprintf(out,"\ninline void disasm::decode_begin(){\n"
	"int opcode;\n"
	"again: opcode=nextbyte();\n"
	"com.op=&dis386[opcode];\n"
	"\tfor(int i=0,t=(com.amode*2+com.osize);i<3;i++)\n"
        "\t	com.opSize[i]=com.op->opSize[i][t];\n");

fprintf(out,"\tswitch(opcode){\n");
    for(int i=0;i<0x100;i++){
    genCase(dis386[i],i);
    }
fprintf(out,"\tdefault:fprintf(stderr,\"Bad opcode 0x%%02x\\n\",opcode);\n\t}\n}");
//end of decode_begin();

// decode_begin_twobyte
fprintf(out,"\ninline void disasm::decode_begin_twobyte(){\n"
	"int opcode;\n"
	"opcode=nextbyte();\n"
	"com.op=&dis386_twobyte[opcode];\n"
	"\tfor(int i=0,t=(com.amode*2+com.osize);i<3;i++)\n"
        "\t	com.opSize[i]=com.op->opSize[i][t];\n");

fprintf(out,"\tswitch(opcode){\n");
    for(int i=0;i<0x100;i++){
    genCase(dis386_twobyte[i],i);
    }
fprintf(out,"\tdefault:fprintf(stderr,\"Bad opcode 0x0f%%02x\\n\",opcode);\n\t}\n}");
//end of decode_begin_twobyte();
    for(int i=0;i<20;i++){
	fprintf(out,"\ninline void disasm::decode_begin_grp%d(){\n"
	    "com.op=&grps[%d][(com.modRM&0x38)>>3];\n"
    	    "\tfor(int i=0,t=(com.amode*2+com.osize);i<3;i++)\n"
            "\t	com.opSize[i]=com.op->opSize[i][t];\n"
	    "\tswitch(com.modRM&0x38){\n",i+1,i);
      for(int j=0;j<8;j++)
      {
          genCase(grps[i][j],j<<3,1);
      }
      fprintf(out,"\t}\n}");
    }
// begin_grpsxx



// end of begin_grpsxx 



fprintf(out,"\n");
fprintf(out,"int disasm::parse_next(){\n"
	    "com.ip=com.lip;\n"
	    "com.amode=bitD;\n"
	    "com.osize=bitD;\n"
	    "com.pref_seg=noSEG;\n"
	    "com.pref_seg=noSEG;\n"
	    "com.pref_rep=com.pref_lock=com.bad=0;\n"
	    "com.operand[0]=com.operand[1]=com.operand[2]="
	    "com.offset=com.segment=0;\n"
	    "decode_begin();\n"
	    "   if(!com.op || !com.op->name || com.bad){\n"
    	    "#ifdef USE_CATCH\n"
	    "      throw 1;\n"
	    "#endif\n"
	    "	com.bad=1;\n"
	    "	return -6;\n"
	    "	}\n"
	    "return 1;\n"
    	    "}\n"
	    "\n"
	    "#define NO_PRINT\n"
	    "#include \"decodes.cpp\""
);

fprintf (out,"\n");;
return 0;
}
