/*
*  This file is part of Emma Virtual Machine
*  Copyright (C) 2003 Vitja Makarov ?<vitja@mail.ru>?
*  
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef DISASM_H
#define DISASM_H

#define F_ALL (F_IP|F_CODE|F_DECODE)
#define F_IP  	 1
#define F_CODE	 2
#define F_DECODE 4

#include "oper.h"
#include "names.h"
#include "addinfo.h"

struct dis386;

struct cmd: ModRMInfo{
int bad;
Bit32u ip;	//source IP(Instruction Pointer)
Bit32u lip;	//ip+CMDLEN

Bit8s pref_seg;
Bit8u pref_rep;
Bit8u pref_lock;

const struct dis386 *op; //pointer to commands database item
// modr/m and sib
Bit8u modRM;
Bit32u offset;
// offset and it's len
Bit32u  operand[3];
Bit16u  segment;
//array that contains operands real lenght in bytes
Bit8u  opSize[3];
// addres mode
// some helpers flags
Bit8u   amode;
Bit8u 	osize;
// array that contains full instruction code
// it was written somewhere that max instruction lenght is 15
// 'll take 20 for diffrent case
char data[20];

inline void operator=(struct ModRMInfo m){
*((struct ModRMInfo *)(this))=m;
}
inline void operator=(struct SIBinfo s){
*((struct SIBinfo *)(this))=s;}
};


enum _state{bad=0x0,Ok=0x1};

class disasm{
public:
disasm();
char *dis(int fmt=F_ALL);
int parse_next();
char *do_out(int fmt=F_ALL);
inline _state state(){return sstate;};

inline void _go32(int a=1){bitD=a;};

private:
char *normname (char *,int ,int);

#if 1
inline int nextbyte()
{
    if(bufpos<buflen || normbuf())
	return com.data[com.lip++-com.ip]=buf[bufpos++];
	else{
        sstate=bad;;
        com.bad=1;
#ifdef USE_CATCH    
        throw 1;
#endif
	}
return 0;	// using catch we lose speed
		// looking for -1 in nextbyte too
		// it's important for CPU
}
#endif
virtual int normbuf();
inline void makePrefixAOP();

#define loadOperand(o,s){	\
    (o)=0;			\
    for(int i=0;i<(s);i++)	\
 	((Bit8u *)&(o))[i]=nextbyte();\
	}

#define decode_modrm(){ 	\
  if(com.amode){		\
     com=modrm32[com.modRM];	\
    if(com.need_sib){		\
     com=sibInfo[nextbyte()];	\
        if(!(com.modRM&0xc0) && com.base==0x5)	\
	    com.base=_zero_,com.disp=4;		\
    }						\
  }else						\
    com=modrm16[com.modRM];			\
    loadOperand(com.offset,com.disp);		\
}

#define loadmodrm() {		\
	com.modRM=nextbyte();	\
	decode_modrm();		\
	}



#ifdef BIGCASE
// for caser
inline void decode_begin();
inline void decode_begin_twobyte();
inline void decode_begin_grp1();
inline void decode_begin_grp2();
inline void decode_begin_grp3();
inline void decode_begin_grp4();
inline void decode_begin_grp5();
inline void decode_begin_grp6();
inline void decode_begin_grp7();
inline void decode_begin_grp8();
inline void decode_begin_grp9();
inline void decode_begin_grp10();
inline void decode_begin_grp11();
inline void decode_begin_grp12();
inline void decode_begin_grp13();
inline void decode_begin_grp14();
inline void decode_begin_grp15();
inline void decode_begin_grp16();
inline void decode_begin_grp17();
inline void decode_begin_grp18();
inline void decode_begin_grp19();
inline void decode_begin_grp20();
#endif
public:
/*
inline void decode_rm(int);
inline void decode_reg(int);
inline void decode_imm(int);
inline void decode_rel(int);
inline void decode_hreg(int);
inline void decode_mx(int);
inline void decode_ptr(int);
*/
inline void decode_regGate(int);
inline void decode_twobyte(int);

#define decode_str(x) 
#define decode_sreg decode_reg
#define decode_creg decode_reg
#define decode_dreg decode_reg

#define decode_hsreg decode_hreg
#define decode_hcreg decode_hreg
#define decode_hdreg decode_hreg

inline void print_rm(int);
//void print_reg(int);
#define print_reg print_hreg
#define print_creg print_hcreg
#define print_dreg print_hdreg
#define print_sreg print_hsreg

inline void print_hsreg(int);
inline void print_hcreg(int);
inline void print_hdreg(int);
inline void print_imm(int);
inline void print_rel(int);
inline void print_str(int);
inline void print_hreg(int);
inline void print_mx(int);
inline void print_ptr(int);

#define print_regGate(x)
#define print_twobyte(x)

#ifndef JUST_DEP
# include "disprn.h"
#endif

//void set_buffer(char *buf,int buflen,int bufpos){
//disasm::buf=buf,disasm::buflen=buflen,disasm::bufpos=bufpos;
//}

char *disout;
char *buf;
int buflen,bufpos;
char bitD;
cmd com;
_state sstate;
};

#endif

