#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define JUST_DEP

#include "dis386.cpp.in"
#include "disasm.h"
#include "addinfo.h"

#define MAX_DB 0x100
static char handlers_db[MAX_DB][30];
static int db_count=0;
static FILE *dis386out=stdout;
//static FILE *putget_out=stdout;
static FILE *disprn_out=stdout;
//static FILE *putget_cpp_out=stdout;
static FILE *disprn_cpp_out=stdout;

int compare(const char *s1,const char *s2){
    if(!s1[0])
	return 1;
    else if(!s2[0])
	return -1;
    
return strcoll(s1,s2);
}
void normalizeDB(int j=-1){
    if(j==-1)
      j=0;
    if(j>db_count)
     return;
 if(handlers_db[j][0])     
    for(int i=0;i<db_count;i++)
    {
	if(i==j)
	 continue;
	 if(!strcmp(handlers_db[i],handlers_db[j]))
	    handlers_db[i][0]='\0';
    }
normalizeDB(j+1);
    if(!j){// we came back
    qsort((void *)handlers_db[0],db_count,sizeof(handlers_db[0]),
    (int (*)(const void *,const void *))compare);
    // and now count new db_count
	for(db_count=0;db_count<MAX_DB;db_count++){
	    if(!handlers_db[db_count][0])
		break;
	}		
    }
}

void addToDB(char *handler){
    if(db_count>=MAX_DB)
	normalizeDB();
    if(db_count>=MAX_DB)
	{	
	    fprintf(stderr,"fatal: MAX_DB now is %d give it larger value\n",MAX_DB);
	    exit(-1);
	}
strcpy(handlers_db[db_count++],handler);
}

void genOpSize(struct dis386 d){
Bit32u op;
fprintf(dis386out,"{");
    for(int i=0;i<3;i++)    
    {
	switch(i){
	case 0:
	op=d.op1;
	break;
	case 1:
	op=d.op2;
	break;
	case 2:
	op=d.op3;
	break;
	default:
	op=0;
	}
	fprintf(dis386out,"{");
	if(op&_o8){
		if(op&_gsign)
		  fprintf(dis386out,"2,4");
		else
		  fprintf(dis386out,"1,1");
	    }
	    
	else if(op&_o16 && op&_o32)
	    fprintf(dis386out,"2,4");
	else if(op&_o16)
	    fprintf(dis386out,"2,2");
	else if(op&_o32)
	    fprintf(dis386out,"4,4");
    	else  
	  fprintf(dis386out,"0,0");

	fprintf(dis386out,"},");
    }

fprintf(dis386out,"},");
}

void genAddInfo(struct dis386 d){
Bit32u op;
char handler[30]="_";

int i;
// does it have modrm?
fprintf(dis386out,"%d,",((d.op1|d.op2|d.op3)&_haveMRM)?1:0);
//fprintf(dis386out,"{%d,",((d.op[0]|d.op[1]|d.op[2])&_haveMRM)?1:0);
// and now set decode handlers
//for(j=0;j<4;j++){fprintf(dis386out,"{");
    for(i=0;i<3;i++){
	switch(i){
	case 0:
	op=d.op1;
	break;
	case 1:
	op=d.op2;
	break;
	case 2:
	op=d.op3;
	break;
	default:
	op=0;
	};
    switch(op&_gmask)
        {
	case _grm:
	strcat(handler,"_rm");
	break;
	case _greg:
	    switch(op&_regMask){
	    case _rcommon:
	    strcat(handler,"_reg");
	    break;
	    case _rseg:
	    strcat(handler,"_sreg");
	    break;
	    case _rdbg:
	    strcat(handler,"_dreg");
	    break;
	    case _rctrl:
	    strcat(handler,"_creg");
	    break;
	    }
	break;
	case _gimm:
	strcat(handler,"_imm");
	break;
	case _grel:
	strcat(handler,"_rel");
	break;
	case _gstr:
	strcat(handler,"_str");
	break;
	case _ghreg:
	    switch(op&_regMask){
	    case _rcommon:
	    strcat(handler,"_hreg");
	    break;
	    case _rseg:
	    strcat(handler,"_hsreg");
	    break;
	    case _rdbg:
	    strcat(handler,"_hdreg");
	    break;
	    case _rctrl:
	    strcat(handler,"_hcreg");
	    break;
	    }
	break;
	case _gmx:
	strcat(handler,"_mx");
	break;
	case _gptr:
	strcat(handler,"_ptr");
	break;
	case _gregGate:
		strcat(handler,"_regGate");
	break; 
	case _gtwobyte:
		strcat(handler,"_twobyte");
	break;    
	case _gno:
	i=3;
	break;
        default:
	fprintf(stderr,"Warning: unhandled group for: %s\n" ,d.name?d.name:"NULL");
	sprintf(handler,"FixMe");
	};
    }
    
      if(handler[1]){
        if(!strcmp(handler,""))
	    {
	    printf("%s\n",d.name);
	    exit(-1);
	    }
#ifndef BIGCASE	    
        	fprintf(dis386out,"&disasm::decode%s,",handler);
#else		
        	fprintf(dis386out,"NULL,");
#endif		
		fprintf(dis386out,"&disasm::print%s,",handler);
//	        fprintf(dis386out,"&CPU::get%s,",handler);
//		fprintf(dis386out,"&CPU::put%s,",handler);
		addToDB(handler);
	}else
	    fprintf(dis386out,"NULL,NULL,");
genOpSize(d);
//fprintf(dis386out,",");// /* %s */",d.name?d.name:"NULL");
}
void genDis386(struct dis386 d){
    fprintf(dis386out,"{");
     if(d.name && d.name[0])
       fprintf(dis386out,"\"%s\",",d.name);
      else
       fprintf(dis386out,"NULL,");
     fprintf(dis386out,"{0x%lx,0x%lx,0x%lx},",d.op1,d.op2,/*d.gateway?0:*/d.op3);
      if(d.gateway){
        if( (d.op1&_gmask) == _gregGate)
          fprintf(dis386out,"grps[%ld],",d.op3);
	 else
	  fprintf(dis386out,"dis386_twobyte,");
      }else
        fprintf(dis386out,"NULL,");
     genAddInfo(d);
     fprintf(dis386out,"},\n");
}

void genModRM16(Bit8u modrm,int _addrsize=0){
struct ModRMInfo dest;
char mod,rm,reg;
dest.base=_zero_;
dest.index=_zero_;
dest.disp=0;
dest.scale=0;
dest.disp=0;
dest.rm_isreg=0;
dest.need_sib=0;
rm=modrm&0x7;
reg=(modrm>>3)&0x7;
mod=modrm>>6;

      switch(mod)
	{
	case 0:
	      if(rm==0x6 && !_addrsize)
   		dest.disp=2;
	      else
		dest.base=rm;
	break;
	case 1:
	dest.base=rm;
	dest.disp=1;	
	break;
	case 2:
	dest.disp=_addrsize?4:2;
	dest.base=rm;
	break;
	case 3:
	dest.base=rm;
	dest.rm_isreg=1;
	break;
	}
dest.reg=reg;
 if(mod!=3)
    switch(rm){
    case 0:
    dest.base=_ebx_;
    dest.index=_esi_;
    break;
    case 1:
    dest.base=_ebx_;
    dest.index=_edi_;
    break;
    case 2:
    dest.base=_ebp_;
    dest.index=_esi_;
    break;
    case 3:
    dest.base=_ebp_;
    dest.index=_edi_;
    break;
    case 4:
    dest.base=_esi_;
    dest.index=_zero_;
    break;
    case 5:
    dest.base=_edi_;
    dest.index=_zero_;
    break;
    case 6:
      if(mod!=0)
        dest.base=_ebp_;
	else
	  dest.base=_zero_;
    dest.index=_zero_;
    break;
    case 7:
    dest.base=_ebx_;
    dest.index=_zero_;
    break;
    }
dest.scale=1;
fprintf(dis386out,"ModRMInfo(%d,%d,%d,%d,%d,%d,%d),\n",dest.base,dest.index,
				   dest.scale,dest.disp,
			    dest.need_sib,dest.rm_isreg,
					        dest.reg);

}

void genSIBinfo(Bit8u modrm){
struct SIBinfo dest;
char ss,index,base;
dest.base=_zero_;
dest.index=_zero_;
//dest.disp=0;
dest.scale=0;
//dest.rm_isreg=0;
//dest.need_sib=0;
base=modrm&0x7;
index=(modrm>>3)&0x7;
ss=modrm>>6;

dest.index=(index==4)?_zero_:index;
dest.scale=1<<ss;
dest.base=base;

fprintf(dis386out,"{%d,%d,%d},\n",dest.base,dest.index,dest.scale);
}

void genModRM32(Bit8u modrm){
struct ModRMInfo dest;
char mod,rm,reg;
dest.base=_zero_;
dest.index=_zero_;
dest.disp=0;
dest.scale=0;
dest.disp=0;
dest.rm_isreg=0;
dest.need_sib=0;
rm=modrm&0x7;
reg=(modrm>>3)&0x7;
mod=modrm>>6;

      switch(mod)
	{
	case 0:
	      if(rm==0x5)
   		dest.disp=4;
	      else if(rm==0x4)
		dest.need_sib=1;
	      else
		dest.base=rm;
	break;
	case 1:
	      if(rm==4) //need SIB byte
		dest.need_sib=1;
		else
		  dest.base=rm;
	dest.disp=1;	
	break;
	case 2:
	      if(rm==4)//need SIB byte
		dest.need_sib=1;
		else
		dest.base=rm;
	dest.disp=4;
	break;
	case 3:
	dest.base=rm;
	dest.rm_isreg=1;
	break;
	}
dest.reg=reg;

fprintf(dis386out,"ModRMInfo(%d,%d,%d,%d,%d,%d,%d),\n",dest.base,dest.index,
				   dest.scale,dest.disp,
			    dest.need_sib,dest.rm_isreg,
					        dest.reg);

}
void genHandler(FILE*protout,char *classname,char *base,char *name){
char dd[10];
fprintf(protout,"void %s::%s%s(){\n",classname,base,name);
name++;
  for(int i=0;;i++){
     if(!(name=strchr(name,'_')))
        break;
    name++;
    strcpy(dd,name);
	for(int j=0;;j++)
	    if(dd[j]==0 || dd[j]=='_'){
	     dd[j]=0;
	     break;
	     }
	if(i && !strcmp(base,"print"))
	    fprintf(protout,"disout+=sprintf(disout,\",\");\n");
	else if(!strcmp(base,"put"))
	    fprintf(protout,"\tif(OP_wasmodifed(%d))\n\t\t",i+1);
    fprintf(protout,"%s_%s(%d);\n",base,dd,i);
    }
fprintf(protout,"}\n");
}

void genHandlers(){
    for(int i=0;i<db_count;i++){
#ifdef BIGCASE    
	fprintf(disprn_out,"inline void decode%s();\n",handlers_db[i]);
#else	
	fprintf(disprn_out,"void decode%s();\n",handlers_db[i]);
#endif
	genHandler(disprn_cpp_out,"disasm","decode",handlers_db[i]);
    }
#ifdef BIGCASE
fprintf(disprn_cpp_out,"#ifndef NO_PRINT\n");
#endif
    for(int i=0;i<db_count;i++){
	fprintf(disprn_out,"void print%s();\n",handlers_db[i]);
//	fprintf(putget_out,"void put%s();\n",handlers_db[i]);
//	fprintf(putget_out,"void get%s();\n",handlers_db[i]);
    
	genHandler(disprn_cpp_out,"disasm","print",handlers_db[i]);
//	genHandler(putget_cpp_out,"CPU","put",handlers_db[i]);
//	genHandler(putget_cpp_out,"CPU","get",handlers_db[i]);
    }
#ifdef BIGCASE
fprintf(disprn_cpp_out,"#endif\n");
#endif
    
}


int main(int /* argc */,char **  argv ){
dis386out=fopen("dis386.cpp","w");
disprn_out=fopen("disprn.h","w");
//putget_out=fopen("putget.h","w");
disprn_cpp_out=fopen("disprn.cpp","w");
//putget_cpp_out=fopen("putget.cpp","w");
fprintf(stderr,"Creating dis386.cpp...\n");

fprintf(dis386out,"// Don't edit file is automaticly created by `%s'\n",argv[0]);
fprintf(dis386out,"// This file contains information for disasm\n");
fprintf(dis386out,"// i think this file have no copyrights, only if as child of `%s'\n",argv[0]);
fprintf(dis386out,"#include \"dis386.h\"\n\n");
//fprintf(dis386out,"#define JUST_DEP\n");
fprintf(dis386out,"#include <stdio.h> /* for NULL declaration */\n\n");

fprintf(dis386out,"struct dis386 dis386[]={\n");
    for(int i=0;i<0x100;i++){
    genDis386(dis386[i]);
    }
fprintf(dis386out,"};\n");    
fprintf(dis386out,"\nstruct dis386 dis386_twobyte[]={\n");
    for(int i=0;i<0x100;i++){
    genDis386(dis386_twobyte[i]);
    }
fprintf(dis386out,"};\n");    

fprintf(dis386out,"\nstruct dis386 grps[][8]={\n");
    for(int i=0;i<8*20;i++){
	if((i%8)==0)
	  fprintf(dis386out,"{");
// special for GRP2_one and GRPbone 5,6 group
	if(i>=40&&i<=55)
	  ((struct dis386 *)grps)[i].op2=1|_gimm|_o8;
	  
    genDis386(((struct dis386 *)grps)[i]);
	if((i%8)==7)
	  fprintf(dis386out,"},");
    }
fprintf(dis386out,"};\n");    
fprintf(dis386out,"\nconst struct ModRMInfo modrm16[0x100]={");
    for(int i=0;i<0x100;i++)
    genModRM16(i);
fprintf(dis386out,"};\n");    
fprintf(dis386out,"\nconst struct ModRMInfo modrm32[0x100]={");
    for(int i=0;i<0x100;i++)
    genModRM32(i);
fprintf(dis386out,"};\n");    
fprintf(dis386out,"\nconst struct SIBinfo sibInfo[0x100]={");
    for(int i=0;i<0x100;i++)
    genSIBinfo(i);
fprintf(dis386out,"};\n");    
normalizeDB();
// and now we should create handlers from db
fprintf(stderr,"Creating disprn.cpp, disprn.h...\n");
genHandlers();

return 0;
}
