/*
*  This file is part of Emma Virtual Machine
*  Copyright (C) 2003 Vitja Makarov ?<vitja@mail.ru>?
*  
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <sys/timeb.h>

#include <unistd.h>
#include <getopt.h>

#include "disasm.h"
#define MAXBUF 1024*1024

// returns value:
// time in seconds + milliseconds/1000
double gettime(){
struct timeb tp;
ftime(&tp);
return (double)tp.time+double(tp.millitm/1000.);
}


class Disasm: public disasm{
public:
Disasm();
virtual ~Disasm();
int openFile(char *name);
void run(int);
int normbuf();
private:
int fd;
};

Disasm::Disasm():disasm(){
buf=(char *)malloc(MAXBUF);
    if(!buf){
	fprintf(stderr,"Couldn't allocate %d bytes\n",MAXBUF);
	exit(-1);
    }
    
bufpos=0;
buflen=0;     
}

Disasm::~Disasm(){
    if(buf)
     free(buf);
}
int Disasm::openFile(char *fn){
fd=open(fn,O_RDONLY);
    if(fd<0){
     perror("open");
     exit(-1);
     }
return fd;
}

int Disasm::normbuf(){
    buflen=read(fd,(void*)buf,MAXBUF);
    if(buflen<=0)
     return 0;
    bufpos=0;
    return 1;    
}

void Disasm::run(int fmt){
unsigned long n=0;

double tt=0;
double t;
t=gettime();


com.lip=0;
    for(;state()!=bad;)
	{
#if 1
	disout=dis(fmt?fmt:F_ALL);
      if(disout)
        puts(disout);
#else
	parse_next(/*&com*/);

#endif	
	n++;
	}
tt=gettime()-t;

fprintf(stderr,"\nOne comand takes %.03e, speed %.03f command/sec\ntotal time %.03f sec\n\
%.03f MIPS, total commands %ld\n",(double)tt/n,1/((double)tt/n),tt,
				    1/((double)tt/n)/1000000.,n);
}

void usage(){
fprintf(stderr,"usage: disasm filename [options]\n");
fprintf(stderr,"\tIt's just also one easy stupid i386 disassembler\n");
fprintf(stderr,"Format options:\n");
fprintf(stderr,"-a print all\n");
fprintf(stderr,"-c print code\n");
fprintf(stderr,"-i print IP\n");
fprintf(stderr,"-d print decode\n");
fprintf(stderr,"-3 print decode\n");
};

int main(int argc,char **argv)
{
Disasm c;
//c.show();
//return 0;
    if(argc<2)
	{
	    usage();
	    exit(1);
	}

    if((c.openFile(argv[1]))<0)
      {
       perror("disasm");
       exit(1);
      }
int cmda=0;
int cc;

   while ((cc = getopt(argc, argv, "icda3")) != -1) {
        switch (cc) {
        case 'i':
	cmda|=F_IP;
	break;
        case 'c':
	cmda|=F_CODE;
	break;
        case 'd':
	cmda|=F_DECODE;
	break;
	case 'a':
	cmda|=F_ALL;
	break;
	case '3':
	c._go32();
	break;
        default:
	exit(-1);
        break;
        }
    }

c.run(cmda);
}
