/*
*  This file is part of Emma Virtual Machine
*  Copyright (C) 2003 Vitja Makarov ?<vitja@mail.ru>?
*  
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>

#include "hardware.h"

Hardware::Hardware()
{
fdN=0;
last_err=DERR_NOERR;
}

int Hardware::addFloppy(char *fn)
{
int fd;
fd=open(fn,O_RDWR);
    if(fd<0)
     return -1;
fds[fdN].fdesc=fd;
// default 3-inch diskette
fds[fdN].sectors = 18;
fds[fdN].heads   = 2;
fds[fdN].tracks  = 80;
fds[fdN].header  = 0;
fdN++;
return 0;
}
struct disk*	
    Hardware::get_disk(int diskN){
    if(diskN>fdN)
      return NULL;
return &fds[diskN];      
}


int Hardware::readSector(int diskN,char *buffer,
	    long head,long sect,long track,long count)
{
/*loff_t*/
long pos=0;
int tmpread;
disk *dp;
    if(diskN>fdN){
      return -BDE_NOMEDIA;
      }
dp=&fds[diskN];      
    if (head >= dp->heads ||
	sect >= dp->sectors || track >= dp->tracks) {
 return -DERR_NOTFOUND;
 }

pos = DISK_OFFSET(dp,head, sect, track) + dp->header;

#ifdef __linux__
  if (pos != lseek(dp->fdesc, pos, SEEK_SET)) {
#else
  if (pos != lseek(dp->fdesc, pos, SEEK_SET)) {
#endif
    fprintf(stderr,"read_sector:Sector not found in read_sector, error = %s!\n",
	  strerror(errno));
    fprintf(stderr,"head=%ld sector=%ld track=%ld count=%ld\n",head,sect,track,count);
    return -DERR_NOTFOUND;
  }else 
tmpread=read(dp->fdesc,buffer,count*SECTOR_SIZE);
return -DERR_NOERR;
}
