/*
*  This file is part of Emma Virtual Machine
*  Copyright (C) 2003 Vitja Makarov ?<vitja@mail.ru>?
*  
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <stdio.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>


#include "cpu.h"
#include "hardware.h"
#include "newinls.h"

Hardware *hw;

static int int_12h(){
REG(ax)=*(Bit16u *)STH_THIS memptr(0x40,0x13);
return 1;
}

static int int_10h(){
    switch(REG(ah))
    {
    case 0xe:
    putchar(REG(al));//!!!
    fflush(stdout);
    break;
    }
return 1;
}

/*
struct EqList{
_byte diskdrv:1;
_byte nm:1
_byte mmoard:2;
_byte vmode:2;
_byte diskn:2;
_byte dma:1;
_byte
};
*/
//EquipmentList
static int int_11h(){
Bit16u eqlist;

//#define EQ_DISKDRV 0x1 //disk driver present
//#define EQ_COPROC  0x2 //coprocessor present
eqlist=0x00;//0+1<<6;One fd present!!!
//store list
REG(ax)=eqlist;
printf("int11: eq=%d\n",eqlist);
return 1;
}

// BIOS disk I/O
static int int_13h(){
short drive, head, sect, track, number;
struct disk *dp=NULL;
int err;
char *dest;
drive=LO(dx);//CPU_DL;
//dp=get_disk(drive);
    switch(HI(ax))
    {
    //reset controller
    case 0:
    
    REG(ah)=0;//now we can't handle errors
    clc();
    break;
    // get status
    case 1:
    // it's realy undone
      if(REG(dl)< hw->fdN )
        REG(ah)=0;
      else
        REG(ah)=0x0c;
    break;
    // read sectors
    case 2:
    dest=(char *) STH_THIS memptr(REG(es),REG(bx));
    drive = REG(dl);
    number= REG(al);
    head  = REG(dh)&0x3f;
    sect=(REG(cl) & 0x3f) - 1;
    track = REG(ch) ;//|
//      ((REG(cx) & 0xc0) << 2);
    
    // store error code in AH as it needed, readSector() should return
    // true bios errorcode 
    err=hw->readSector(drive,dest,head,sect,track,number);    
	if(err<0){
	  REG(ah)=-err;
	  stc();
	  }else{
	  REG(al)=err>>9;//
	  clc();
	  }
	 
    break;
// get drive parameters    
    case 0x8:
    dp=hw->get_disk(drive);
    	if(dp){
#if 0
      switch (dp->sectors) {
      case 9:
	LO(bx) = 3;
	break;
      case 15:
	LO(bx) = 2;
	break;
      case 18:
	LO(bx) = 4;
	break;
      case 0:
	LO(bx) = dp->default_cmos;
	dp->tracks = 80;
	dp->heads = 2;
	if (LO(bx) == 4)
	  dp->sectors = 18;
	else
	  dp->sectors = 15;
	d_printf("auto type defaulted to CMOS %d, sectors: %d\n", LO(bx), dp->sectors);
	break;
      default:
	LO(bx) = 4;
	d_printf("type det. failed. num_tracks is: %d\n", dp->tracks);
	break;
      }
#endif 
     LO(bx)=4;
      /* these numbers are "zero based" */
      REG(dh) = dp->heads - 1;
      REG(ch) = (dp->tracks - 1) & 0xff;

      REG(dl) = 1;//(disk < 0x80) ? FDISKS : HDISKS;
      REG(cx) = dp->sectors | (((dp->tracks -1) & 0x300) >> 2);
      REG(al) = 0;
      REG(ah) = DERR_NOERR;
      clc();
	}else{// on error
	REG(dx)=1;
	REG(cx)=0;
	REG(bl)=0;
	REG(ah)=DERR_BADCMD;
	stc();
	}
    printf("int13 get param: drive=%02x error=%d\n",drive,
	    get_bit(__eflags,CF)?REG(ah):0);
    break;
    case 0x15:
    dp=hw->get_disk(drive);
    	if(dp){
	   if(drive<0x4)
	    _AH=1;
	    else
	     _AH=0x3;
	}else{
	_AH=0;//not installed
	}    
    clc();
    printf("int13 hd/fd type: drive=%02x return=%02x\n",drive,REG(ah));
    break;
    default: 
    fprintf(stderr,"Unhandled interrupt 13: AH=0x%x\n",REG(ah));
    stc();
    }
return 1;
}
#if 0
char readCHAR(){
int  c,r;
int yn=0;
int fd=0;
ioctl(fd, FIONBIO, &yn);
    c=0;
    r=read(fd,&c,1);
      if(r>0)
	return c;
	else
	 return 0;
}
#endif
static int int_16h(){
printf("int16h: AH=%02x\n",HI(ax));
    switch(REG(ah))
    {
    case 0x0:
    REG(al)=0xd;//getchar();
    ///readCHAR();
//    CPU_AH=CPU_AL;
    break;
    case 0x1:
    clear_bit(__eflags,ZF);
//    CPU_AH=' ';
//    CPU_AH=0x23;
    break;
    }
return 1;
}

static int int_15h(){
printf("int15h:AH=%02x\n",_AH);
    switch(REG(ah)){
    case 0xc0:
    _AH=0x86;
    stc();
    break;
    default:
    stc();
    }
return 1;
}

static int int_14h(){
printf("int14h:AH=%02x\n",_AH);
    switch(REG(ah)){
    case 0x0:
    _AX=0;
    stc();
    break;
    case 0x1:
    _AH=0x80;
    break;
    default:
    stc();
    }
return 1;
}

static int int_17h(){
printf("int17h:AH=%02x\n",_AH);
    switch(REG(ah)){
    case 0x1:
    _AH=0x8;
    break;
    default:
    stc();
    }
return 1;
}


static int int_1ah(){
    switch(REG(ah))
    {
    case 0:
    REG(al)=0;
    REG(cx)=0;
    REG(dx)=0;
    break;
    case 2:
    REG(ax)=0;
    REG(cx)=0;
    REG(dh)=0;
    set_bit(__eflags,CF);
    break;
    case 4:
    break;
    }
return 1;
}

//
void CPU::emmaCtrl(){
int n;

    n = *(char *) loadImm8();

//printf("Got int%Xh\n",n);
    switch(n)
    {
    case 0x13:
    int_13h();
    break;    
    case 0x11:
    int_11h();
    break;    
    case 0x12:
    int_12h();
    break;    
    case 0x10:
    int_10h();
    break;    
    case 0x16:
    int_16h();
    break;     
//  case 0x19:
//  int_19h();
//  break;    
    case 0x1a:
    int_1ah();
    break;    
    case 0x15:
    int_15h();
    break;    
    case 0x14:
    int_14h();
    break;
    case 0x17:
    int_17h();
    break;
    default:
    fprintf(stderr,"Unhandled interrupt 0x%x: AH=%x\n",n,REG(ah));
    }
//turn 0;    
};
