#include <stdlib.h>
#include <string.h>
#include "cpu/cpu.h"
#undef CF
#undef PF
#undef ZF
#undef TF
#undef IF
#undef DF
#undef AF
#undef OF
#undef SF


#include "cpu.h"

#include "global.h"
//#include "vgahard.h"
extern volatile int in_debug;

extern "C" void diff_cpu();
extern "C" void next_pcemu_step();
extern   void init_emma_cpu();
extern "C" void vga_interrupt();

struct CPU_context{
WORD wregs[8];       /* Always little-endian */
//BYTE *bregs[16];     /* Points to bytes within wregs[] */
unsigned sregs[6];   /* Always native machine word order */
unsigned ip;         /* Always native machine word order */
		     /* All the byte flags will either be 1 or 0 */
BYTE CF, PF, ZF, TF, IF, DF;
    /* All the word flags may be either none-zero (true) or zero (false) */
unsigned AF, OF, SF;
//BYTE *c_cs,*c_ds,*c_es,*c_ss,*c_stack;
BYTE *mem;
};

void save_context(CPU_context &c){
memcpy(&c.wregs,&wregs,sizeof(wregs));
//c.bregs=bregs;
memcpy(&c.sregs,&sregs,sizeof(sregs));
c.ip=ip;
c.CF=CF?1:0;
c.PF=PF?1:0;
c.ZF=ZF?1:0;
c.TF=TF?1:0;
c.IF=IF?1:0;
c.DF=DF?1:0;
c.AF=AF?1:0;
c.OF=OF?1:0;
c.SF=SF?1:0;
bregs[AL] = (BYTE *)&wregs[AX];
bregs[AH] = (BYTE *)&wregs[AX]+1;
bregs[CL] = (BYTE *)&wregs[CX];
bregs[CH] = (BYTE *)&wregs[CX]+1;
bregs[DL] = (BYTE *)&wregs[DX];
bregs[DH] = (BYTE *)&wregs[DX]+1;
bregs[BL] = (BYTE *)&wregs[BX];
bregs[BH] = (BYTE *)&wregs[BX]+1;
    
bregs[SPL] = (BYTE *)&wregs[SP];
bregs[SPH] = (BYTE *)&wregs[SP]+1;
bregs[BPL] = (BYTE *)&wregs[BP];
bregs[BPH] = (BYTE *)&wregs[BP]+1;
bregs[SIL] = (BYTE *)&wregs[SI];
bregs[SIH] = (BYTE *)&wregs[SI]+1;
bregs[DIL] = (BYTE *)&wregs[DI];
bregs[DIH] = (BYTE *)&wregs[DI]+1;
//c.mem=memory;
}

void restore_context(CPU_context c){
memcpy(&wregs,&c.wregs,sizeof(wregs));
//c.bregs=bregs;
memcpy(&sregs,&c.sregs,sizeof(sregs));
ip=c.ip;
CF=c.CF?1:0;
PF=c.PF?1:0;
ZF=c.ZF?1:0;
TF=c.TF?1:0;
IF=c.IF?1:0;
DF=c.DF?1:0;
AF=c.AF?1:0;
OF=c.OF?1:0;
SF=c.SF?1:0;
c_cs = SegToMemPtr(CS);
c_ds = SegToMemPtr(DS);
c_es = SegToMemPtr(ES);
c_stack = c_ss = SegToMemPtr(SS);
memory=c.mem;
}
void dumpContext(CPU_context c){
    fprintf(stderr,"\nAX=%04X  BX=%04X  CX=%04X  DX=%04X "
           "SP=%04X  BP=%04X  SI=%04X  DI=%04X\n",
           c.wregs[AX],c.wregs[BX],c.wregs[CX],c.wregs[DX],c.wregs[SP],
           c.wregs[BP],c.wregs[SI],c.wregs[DI]);
    fprintf(stderr,"DS=%04X  ES=%04X  SS=%04X  CS=%04X  IP=%04X\n"
           "OF=%d DF=%d IF=%d SF=%d ZF=%d AF=%d PF=%d CF=%d TF=%d\n",c.sregs[DS],c.sregs[ES],c.sregs[SS],c.sregs[CS],
           c.ip, c.OF ? 1:0, c.DF  ? 1:0, c.IF  ? 1:0,
           c.SF  ? 1:0, c.ZF  ? 1:0,c.AF ? 1:0,
           c.PF  ? 1:0, c.CF  ? 1:0,c.TF ? 1:0 );
    fprintf(stderr,"CS:IP\t");
    for(int i=0;i<15;i++)
    fprintf(stderr,"%02x ",c.mem[c.ip+(c.sregs[CS]<<4)+i]);
    fprintf(stderr,"\n");
}
// here we should to diff two contextes
int diff_contextes(CPU_context c1,CPU_context c2,char *n1="c1",char *n2="c2"){
    try{
	if(memcmp(c1.sregs,c2.sregs,sizeof(c1.sregs)))
	 throw 1;
	if(memcmp(c1.wregs,c2.wregs,sizeof(c1.wregs)))
	 throw 1;
	if(c1.ip!=c2.ip)
	 throw 1;
//      if(c1.CF!=c2.CF) throw 1;
//	if(c1.PF!=c2.PF) throw 1;
//	if(c1.ZF!=c2.ZF) throw 1;
//	if(c1.TF!=c2.TF) throw 1;
//	if(c1.IF!=c2.IF) throw 1;
//	if(c1.DF!=c2.DF) throw 1;
//	if(c1.AF!=c2.AF) throw 1;
//	if(c1.OF!=c2.OF) throw 1;
//	if(c1.SF!=c2.SF) throw 1;
    }catch(int i){// context are diffrent
//    fprintf(stderr,"%s and %s are diffrent:\n",n1,n2);
    fprintf(stderr,"%s:",n1);
     dumpContext(c1);
    fprintf(stderr,"%s:",n2);
     dumpContext(c2);
     return 0;
    }
return 1;    
}


extern CPU *cpu;
void diff_cpu(){
cmd com;
CPU_context pcemu,emma,pcemuold,emmaold;
save_context(pcemu);
save_context(emma);
pcemu.mem=memory;
emma.mem=(BYTE *)malloc(MEMORY_SIZE);
memcpy(emma.mem,pcemu.mem,MEMORY_SIZE);
restore_context(emma);
init_emma_cpu();
int IIII=0;
pcemuold=pcemu;
emmaold=emma;
in_debug=0;
    for(;;){
#if 1
    restore_context(pcemu);
    next_pcemu_step();
//    vga_interrupt();
    save_context(pcemu);
//    continue;
//    restore_context(emma);
#endif
    cpu->sync_regs_down();
    cpu->run(1);
    cpu->sync_regs_down();
//    vga_interrupt();    
    save_context(emma);
//    continue;
	if(!diff_contextes(emma,pcemu,"emma","pcemu")){
	        
//	    com.lip=com.eip;
	if(!IIII){
	    fprintf(stderr,"Diff block begins:\n");
	    fprintf(stderr,"%s\n***********************************************\n",cpu->do_out());
	}	    
	    fprintf(stderr,"emma old:");	    
    	    dumpContext(emmaold);
	    fprintf(stderr,"pcemuold old:");	    
    	    dumpContext(pcemuold);
	    
	    
	    
	    fflush(stderr);
	if(!IIII)	    {
	FILE *f1,*f2;
	f1=fopen("memdump.emma","w");
	f2=fopen("memdump.pcemu","w");
	fwrite(emma.mem,1,MEMORY_SIZE,f1);
	fwrite(pcemu.mem,1,MEMORY_SIZE,f2);
	fclose(f1);    
	fclose(f2);   
        IIII=1;
    
	    getchar();
	    }
	}else if(IIII){
	IIII=0;
	fprintf(stderr,"Block ENDS;\n");
	}
    pcemuold=pcemu;
    emmaold=emma;
    }

}
