#!/bin/sh
#
#	This script is part Of Emma Virtual Machine
#	Vitja Makarov, 2003 (c)
#
#		this script should be called by next command or simile:
#		cd..&&make dist

DISTNAME=emma
TIME=`date +"%Y%m%d"`
USER=`whoami`
PWD=`pwd -P`
Cwd=`basename $PWD`
FULLNAME=$DISTNAME-$USER-$TIME.tar.gz
DIST_FILES_RULES="\.cpp$|\.c$|\.h$|\.in$|Makefile|TODO$|ChangeLog$|COPYING$\
|license$|VERSION$|\.l$|\
\.sh$|\.gdbinit|\.s$|\.asm$|makedist|makepatch|names_o$|names_cpp$"
# create dist list file

cd .. && find $Cwd|egrep -ie $DIST_FILES_RULES>dist_list

printf "If you have added to distribution files, that don't accord to the\n\
following rules add them to rules:\n %s\n" $DIST_FILES_RULES
printf "Default name of archive is:$FULLNAME\n"
printf "Input any one or press enter:"
read TMP_NAME
    if [ $TMP_NAME ]; then
	FULLNAME=$TMP_NAME
    fi
printf "Creating archive ../%s\n" $FULLNAME
tar --files-from=dist_list -cv | gzip -f9 > $FULLNAME
rm -f dist_list
printf "Done\n"
